
void set_lower(int lower){
  if(lower < hist[chid].lower || lower > hist[chid].upper){
    printf("%d < val < %d\n",hist[chid].lower,hist[chid].upper);
  }else{
    if(hinfo[chid].wln != 0){
      hinfo[chid].wln = (int)((float)hist[chid].bin/
       ((float)(hist[chid].upper - hist[chid].lower)/(float)lower));
    }else{
      hinfo[chid].wln = 0;
    }
  }
}

void set_upper(int upper){
  if(upper > hist[chid].upper || upper <hist[chid].lower){
    printf("%d < val < %d\n",hist[chid].lower,hist[chid].upper);
  }else{
    hinfo[chid].wun = (int)((float)hist[0].bin/
      ((float)(hist[chid].upper - hist[chid].lower)/(float)upper));
  }
}

void hlist(void){
  int i;

  printf("1D Histogram\n");
  for(i=0;i<chsum;i++){
    printf("HID(%d) \"%s\"  ",hist[i].id+1,hist[i].name);
    printf("%4d-%4d (BIN %d)\n",hist[i].lower,hist[i].upper,hist[i].bin);
  }
  printf("2D Histogram\n");
  for(i=0;i<dchsum;i++){
    printf("HID2(%d) \"%s\"  ",dhist[i].id+1,dhist[i].name);
    printf("X:%4d-%4d (BIN %d)",dhist[i].xlower,dhist[i].xupper,dhist[i].xbin);
    printf("  Y:%4d-%4d (BIN %d)\n",dhist[i].ylower,dhist[i].yupper,dhist[i].ybin);
  }


}

int chhist(char *arg){
  int id;

  if(sscanf(arg,"%d",&id) != 1){
    printf("Invalid value.\n");
    return -1;
  }

  if(id < 1 || id > chsum){
    printf("No such Histogram(%d)\n",id);
    return -1;
  }else{
    chid = id-1;
    XtVaSetValues(histMenuButton,XtNlabel,hist[id].name,NULL);
    update_hist();
  }

  return 0;
}

int com_hx(char *arg){
  int lower,upper;

  lower = -1;
  upper = -1;

  if(sscanf(arg,"%d %d",&lower,&upper) != 2){
    printf("Invalid value.\n");
    return -1;
  }
  if(lower >= 0 && upper >= 0 && lower < upper){
    set_lower(lower);
    set_upper(upper);
    update_hist();
  }else{
    printf("Invalid value.\n");
    return -1;
  }
  return 0;
}



int expand_hist(int x){
  int owun,owln,twun,twln;

  x = cx2bin(x);

  owun = hinfo[chid].wun;
  owln = hinfo[chid].wln;
  if((owun - owln) < 3){
    printf("Can't expand no more.\n");
    return -1;
  }

  twun = x+(owun-owln)/4;
  twln = x-(owun-owln)/4;
  if(twln < 0){
    twun = twun - twln;
    twln = 0;
  }
  if(twun > hist[chid].bin){
    twln = twln - (twun - hist[chid].bin);
    twun = hist[chid].bin;
  }
  hinfo[chid].wun = twun;
  hinfo[chid].wln = twln;

  update_hist();

  return 0;
}

void set_xyLabel(int x){
  int y;
  char xystr[12];
  x = cx2bin(x);
  y = hist[chid].data[x];
  x = bin2val(&hist[chid],x);

  snprintf(xystr,sizeof(xystr),"%d:%d",x,y);
  XtVaSetValues(xyLabel,XtNlabel,xystr,NULL);
}

void update_hist(void){
  if(chsum > 0){
    draw_hist1d(&canvas,chid);
  }
  if(dchsum > 0){
    draw_hist2d(&dcanvas,dchid);
  }
}

void wide_hist(void){
  hinfo[chid].wun = hist[chid].bin;
  hinfo[chid].wln = 0;

  update_hist();
}

void book(char *arg){
  int i,anaseg;


  mkhist(arg,&anaseg,&hist,&dhist,&chsum,&dchsum);

  if(anaseg < 1 || anaseg > 50){
    seg.id = 1;
  }else{
    seg.id = anaseg;
  }

  for(i=0;i<chsum;i++){
    mkhist1d(&hist[i]);
  }
  for(i=0;i<dchsum;i++){
    mkhist2d(&dhist[i]);
  }

  for(i=0;i<chsum;i++){
    hinfo[i].hamp = 1;
    hinfo[i].wamp = 1;
    hinfo[i].hln = 0;
    hinfo[i].hun = ch;
    hinfo[i].wln = 0;
    hinfo[i].wun = hist[i].bin;
  }

  for(i=0;i<dchsum;i++){
    dhinfo[i].hamp = 1;
    dhinfo[i].yln = 0;
    dhinfo[i].yun = dhist[i].ybin;
    dhinfo[i].xln = 0;
    dhinfo[i].xun = dhist[i].xbin;
  }
}

void erase(void){
  char *ynstr;
  int i;

  ynstr = readline("Erase Histogram contents ? [y/n] : ");
  if(ynstr[0] == 'y'){
    for(i=0;i<chsum;i++){
      erasehist1d(&hist[i]);
    }
    for(i=0;i<dchsum;i++){
      erasehist2d(&dhist[i]);
    }
  }
}

void anastart(char *arg){
  char fname[256];
  int ff,len;

  if(stflag == False){
    if(sscanf(arg,"%s",fname) == 1){
      len = strlen(fname);
      openRawData(fname,&len,&ff);
      if(ff == 0){
	stflag = True;
	anamode = 1;
	printf("Start -- data from file.\n");
      }else{
	printf("Can't open %s\n",fname);
      }
    }else{
      initDataClient();
      stflag = True;
      anamode = 0;
      printf("Start -- data from analyzer.\n");
    }
  }
}

void anastop(void){
  printf("stop\n");
  if(stflag == True){
    stflag = False;
  }
}

void analys(void){
  int i;
  unsigned short blkflag;

  while(1){
    nari_getevt__(blk,evt,&blkflag);
    if(blkflag == NORMAL_EVT){
      segsplit(evt,&seg);
      for(i=0;i<chsum;i++){
	addhist1d(&hist[i],seg.data[hist[i].src]);
      }
      for(i=0;i<dchsum;i++){
	addhist2d(&dhist[i],seg.data[dhist[i].xsrc],seg.data[dhist[i].ysrc]);
      }
    }else if(blkflag == END_BLK || blkflag == ERROR_BLK ||
	     blkflag == COMMENT_BLK){
      break;
    }
  }
}

int hist2asc(char *arg){
  FILE *fd;
  char fname[256];
  int hid,i;

  if(sscanf(arg,"%d %s",&hid,fname) != 2){
    printf("h2a hid filename\n");
    return -1;
  }
  if(hid < 1 || hid > chsum){
    printf("No such Histogram(%d)\n",hid);
    return -1;
  }
  if((fd = fopen(fname,"w")) == NULL){
    printf("Can't open %s.\n",fname);
    return -1;
  }

  hid--;

  for(i=0;i<hist[hid].bin;i++){
    fprintf(fd,"%d %d\n",i,hist[hid].data[i]);
  }

  fclose(fd);

  return 0;
}

int linecom(void){
  while(1){
    line = readline("COM : ");
    
    if(!line){
      break;
    }
    
    com = stripwhite(line);
    if(*com){
      add_history(com);
      execute_line(com);
    }
    
    free(line);
  }
  return 0;
}

