XColor redcol,bluecol,histcol,dcol[10];
Display *dis;
Window win,dwin;
Pixmap pix,dpix;
GC gc,gc_clr,dgc,dgc_clr;

void init_dis(Widget *can){
  dis = XtDisplay(*can);
  win = XtWindow(*can);
  dwin = XtWindow(dcanvas);
  gc = DefaultGC(dis,DefaultScreen(dis));
  XSetBackground(dis,gc,WhitePixel(dis,0));
  XSetForeground(dis,gc,BlackPixel(dis,0));

  gc_clr = XCreateGC(dis,win,0,0);
  XSetBackground(dis,gc_clr,WhitePixel(dis,0));
  XSetForeground(dis,gc_clr,WhitePixel(dis,0));

  dgc = DefaultGC(dis,DefaultScreen(dis));
  XSetBackground(dis,gc,WhitePixel(dis,0));
  XSetForeground(dis,gc,BlackPixel(dis,0));

  dgc_clr = XCreateGC(dis,dwin,0,0);
  XSetBackground(dis,dgc_clr,WhitePixel(dis,0));
  XSetForeground(dis,dgc_clr,WhitePixel(dis,0));
}

void set_cmap(void){
  Colormap cmap;
  int ii,i,rr,gg,bb;

  Display *dis = XtDisplay(canvas);
  GC gc;
  gc = DefaultGC(dis,DefaultScreen(dis));
  cmap = DefaultColormap(dis,0);

  bluecol.red = 0x0000;
  bluecol.green = 0x0000;
  bluecol.blue = 0xffff;
  ii = XAllocColor(dis,cmap,&bluecol);

  redcol.red = 0xffff;
  redcol.green = 0x0000;
  redcol.blue = 0x0000;
  ii = XAllocColor(dis,cmap,&redcol);

  histcol.red = 0x3333;
  histcol.green = 0x9999;
  histcol.blue = 0xcccc;
  ii = XAllocColor(dis,cmap,&histcol);

  i=0;
  dcol[i].red = 0x0000;
  dcol[i].green = 0x0000;
  dcol[i].blue = 0x9999;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0x0000;
  dcol[i].green = 0x0000;
  dcol[i].blue = 0xcccc;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0x0000;
  dcol[i].green = 0x9999;
  dcol[i].blue = 0xcccc;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0x0000;
  dcol[i].green = 0xcccc;
  dcol[i].blue = 0x6666;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0x0000;
  dcol[i].green = 0xcccc;
  dcol[i].blue = 0x0000;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0x9999;
  dcol[i].green = 0xcccc;
  dcol[i].blue = 0x0000;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0xcccc;
  dcol[i].green = 0xffff;
  dcol[i].blue = 0x0000;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0xcccc;
  dcol[i].green = 0x9999;
  dcol[i].blue = 0x0000;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0xffff;
  dcol[i].green = 0x6666;
  dcol[i].blue = 0x0000;
  ii = XAllocColor(dis,cmap,&dcol[i]);

  i++;
  dcol[i].red = 0xffff;
  dcol[i].green = 0x0000;
  dcol[i].blue = 0x0000;
  ii = XAllocColor(dis,cmap,&dcol[i]);
}


int draw_hist1d(Widget *can,int id){
  int h,w,x,y,i,hbin;
  char yuc[20],ylc[20],xuc[20],xlc[20];
  int yun,yln,xun,xln;

  XtVaGetValues(*can,XtNwidth,&cw,XtNheight,&ch,
		XtNx,&cx,XtNy,&cy,NULL);
  cw &= 0xffff;
  ch &= 0xffff;
  cx &= 0xffff;
  cy &= 0xffff;

  pix = XCreatePixmap(dis,win,cw,ch,DefaultDepth(dis,0));
  XFillRectangle(dis,pix,gc_clr,0,0,cw,ch);

  XSetForeground(dis,gc,histcol.pixel);
  hbin = hinfo[id].wun - hinfo[id].wln;

  w = cw/hbin;
  x = 0;
  y = 0;

  if(w == 0){
    w = 1;
    hinfo[id].wamp = hbin/cw;
  }else{
    hinfo[id].wamp = 1;
  }

  for(i=hinfo[id].wln;i<hinfo[id].wun;i+=hinfo[id].wamp){
    h = hist[id].data[i];
    if(hinfo[id].hamp != -1){
      y = ch-(h/hinfo[id].hamp);
    }else{
      y = ch-calcLog(h);
      h = calcLog(h);
    }

    XFillRectangle(dis,pix,gc,x,y,w,h);
    x += w;
  }

  XCopyArea(dis,pix,win,gc,0,0,cw,ch,0,0);

  if(hinfo[id].hamp != -1){
    yun = (ch-(ch%50))*hinfo[id].hamp;
    sprintf(yuc,"%d",yun);
  }else{
    sprintf(yuc,"10E%d",(int)(ch/50));
  }
  yln = 0;
  sprintf(ylc,"%d",yln);
  xun = (hist[id].upper - hist[id].lower)*hinfo[id].wun/hist[id].bin;
  sprintf(xuc,"%d",xun);
  xln = (hist[id].upper - hist[id].lower)*hinfo[id].wln/hist[id].bin;
  sprintf(xlc,"%d",xln);

  XtVaSetValues(yuLabel,XtNlabel,yuc,NULL);
  XtVaSetValues(ylLabel,XtNlabel,ylc,XtNvertDistance,ch-lh-20,NULL);
  XtVaSetValues(xlLabel,XtNlabel,xlc,XtNvertDistance,ch-lh,NULL);
  XtVaSetValues(xuLabel,XtNlabel,xuc,XtNhorizDistance,cw-lw-40,
  		XtNvertDistance,-lh,NULL);
  return 0;
}

int draw_hist2d(Widget *can,int id){
  int dx,dy,dxbin,dybin;
  int x,y,xw,yw,i,j,dd;

  XtVaGetValues(*can,XtNwidth,&dcw,XtNheight,&dch,
		XtNx,&dcx,XtNy,&dcy,NULL);
  dcw &= 0xffff;
  dch &= 0xffff;
  dcx &= 0xffff;
  dcy &= 0xffff;

  dpix = XCreatePixmap(dis,dwin,dcw,dch,DefaultDepth(dis,0));
  XFillRectangle(dis,dpix,dgc_clr,0,0,dcw,dch);

  dxbin = dhinfo[id].xun - dhinfo[id].xln;
  dybin = dhinfo[id].yun - dhinfo[id].yln;

  xw = dcw/dxbin;
  yw = dch/dybin;
  x = 0;
  y = dch;

  if(xw == 0 || yw == 0){
    XDrawString(dis,dpix,dgc,10,10,"Too narrow",10);
    return -1;
  }
  for(i=0;i<dhist[id].xbin;i++){
    for(j=0;j<dhist[id].ybin;j++){
      if(dhist[id].data[i][j] > 0){
	dd = dstep(dhist[id].data[i][j],dmode);
	XSetForeground(dis,dgc,dcol[dd].pixel);
	XFillRectangle(dis,dpix,dgc,x,y-yw,xw,yw);
      }
      y -= yw;
    }
    x += xw;
    y = dch;
  }

  XCopyArea(dis,dpix,dwin,dgc,0,0,dcw,dch,0,0);
}

int draw_cur1(Widget *can,int x){
  XSetForeground(dis,gc,bluecol.pixel);
  XtVaGetValues(*can,XtNwidth,&cw,XtNheight,&ch,
		XtNx,&cx,XtNy,&cy,NULL);
  cw &= 0xffff;
  ch &= 0xffff;
  cx &= 0xffff;
  cy &= 0xffff;

  XDrawLine(dis,win,gc,x,ch,x,0);

  return 0;
}

int draw_cur2(Widget *can,int x){
  XSetForeground(dis,gc,redcol.pixel);

  XtVaGetValues(*can,XtNwidth,&cw,XtNheight,&ch,
		XtNx,&cx,XtNy,&cy,NULL);
  cw &= 0xffff;
  ch &= 0xffff;
  cx &= 0xffff;
  cy &= 0xffff;

  XDrawLine(dis,win,gc,x,ch,x,0);

  return 0;
}
