#include <stdlib.h>

#include "histogram.h"

int mkhist1d(struct hist1d *hist){

  hist->data = calloc(hist->bin,4);

  if(hist->data == NULL){
    return -1;
  }

  return 0;
}

int mkhist2d(struct hist2d *hist){
  int i,j;

  hist->data = (unsigned int **)malloc(4*hist->xbin);
  for(i=0;i<hist->ybin;i++){
    hist->data[i] = (int *)malloc(4*hist->ybin);
  }

  if(hist->data == NULL){
    return -1;
  }

  for(i=0;i<hist->xbin;i++){
    for(j=0;j<hist->ybin;j++){
      hist->data[i][j] = 0;
    }
  }

  return 0;
}

int addhist1d(struct hist1d *hist,unsigned short val){
  int step;

  if(hist->lower < val && hist->upper > val){
    step = (hist->upper - hist->lower)/hist->bin;
    hist->data[val/step]++;
  }

  return 0;
}

int addhist2d(struct hist2d *hist,unsigned short xval,unsigned short yval){
  int stepx,stepy;

  if(hist->xlower < xval && hist->xupper > xval
     && hist->ylower < yval && hist->yupper > yval){
    stepx = (hist->xupper - hist->xlower)/hist->xbin;
    stepy = (hist->yupper - hist->ylower)/hist->ybin;
    hist->data[xval/stepx][yval/stepy]++;
  }else{
    return -1;
  }

  return 0;
}


int erasehist1d(struct hist1d *hist){
  int i;

  for(i=0;i<hist->bin;i++){
    hist->data[i] = 0;
  }

  return 0;
}

int erasehist2d(struct hist2d *hist){
  int i,j;

  for(i=0;i<hist->xbin;i++){
    for(j=0;j<hist->ybin;j++){
      hist->data[i][j] = 0;
    }
  }

  return 0;
}
