#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <math.h>

#include <sys/time.h>
#include <sys/types.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xutil.h>

#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/Toggle.h>

#include <readline/readline.h>
#include <readline/history.h>

#include "dataclient.h"

#define PROGNAME "nbbqhist"

static char *fallbackResources[] = {
  "bbhist*font: rk14",
  NULL
};

#define         NORMAL_EVT      0
#define         END_BLK         1
#define         COMMENT_BLK     2
#define         ERROR_BLK       3

#include "segdata.h"
#include "histogram.h"
#include "common.h"
#include "widget.c"
#include "util.c"
#include "graphic.c"
#include "event.c"
#include "command.c"

void quit(void){
  XtUnrealizeWidget(toplevel);
  printf("exit\n");
  exit(0);
}

void XAppMain(void){
  XEvent evt;

  while(XtAppPending(ac)){
    XtAppNextEvent(ac,&evt);
    XtDispatchEvent(&evt);
  }
}

void alrm_evt(void){
  if(stflag == True){
    getData(blk,&newdata);
    if(newdata == 0){
      analys();
      update_hist();
    }else if(newdata == 3){
      printf("EOF\n");
      anastop();
    }
  }
  XAppMain();
}

/* main loop */
int main(int argc,char *argv[]){

  if(argc != 2){
    printf("bbhist FILE.\n");
    exit(0);
  }
  book(argv[1]);
  makeWidget();

  sa.sa_handler = (void *)alrm_evt;
  sa.sa_flags = 0;
  sigaction(SIGALRM,&sa,&osa);

  itv.it_interval.tv_sec = 0 ;
  itv.it_interval.tv_usec = 10000;
  itv.it_value.tv_sec = 0 ;
  itv.it_value.tv_usec = 10000;

  chid = 0;
  dchid = 0;

  set_cmap();

  showFrame();
  XtVaSetValues(histMenuButton,XtNlabel,hist[chid].name,NULL);
  XtVaSetValues(dhistMenuButton,XtNlabel,dhist[dchid].name,NULL);


  setitimer(ITIMER_REAL,&itv,&otv);

  linecom();
  
  return 0;
}
