#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

int execute_line(char *ll);

/* The names of functions that actually do the manipulation. */
int com_list(),com_view(),com_stat (),com_pwd();
int com_help(),com_cd(),com_quit();
void quit(void);

int com_hx();

void hwhist(Widget w, XtPointer client, XtPointer call);
void hhhist(Widget w, XtPointer client, XtPointer call);
void hlhist(Widget w, XtPointer client, XtPointer call);
void hlist(void); void erase(void);
int chhist(void); void anastart(char *arg);
void anastop(void); void analys(void);
void book(char *arg);
extern int mkhist();
int hist2asc();

typedef struct{
  char *name;
  Function *func;
  char *doc;
}COMMAND;

COMMAND commands[]={
  {"exit",(Function *)quit,"Exit bbhistogramer"},
  {"quit",(Function *)quit,"Quit bbhistogramer"},
  {"cd", com_cd, "Change to directory DIR" },
  {"help", com_help, "Display this text" },
  {"?", com_help, "Synonym for `help'" },
  {"list", com_list, "List files in DIR" },
  {"ls", com_list, "Synonym for `list'" },
  {"pwd", com_pwd, "Print the current working directory" },
  {"stat", com_stat, "Print out statistics on FILE" },
  {"view", com_view, "View the contents of FILE" },
  {"hw",(Function *)hwhist,"Doble height histogram"},
  {"hh",(Function *)hhhist,"Half height histogram"},
  {"hl",(Function *)hlhist,"log plot histogram"},
  {"hx",(Function *)com_hx,"X axis (hx lower upper)"},
  {"hlist",(Function *)hlist,"Histogram list"},
  {"chhist",(Function *)chhist,"Change Histogram"},
  {"erase",(Function *)erase,"Erase Histogram contents"},
  {"h2a",(Function *)hist2asc,"Histogram to ascii (h2a hid filename)"},
  {"start",(Function *)anastart,"Start On-line monitor"},
  {"stop",(Function *)anastop,"Stop On-line monitor"},
  {(char *)NULL,(Function *)NULL,(char *)NULL}
};

char *stripwhite(char *line);
COMMAND *find_command();

int valid_argument(char *caller,char *arg);

char *progname;
int done;
