#include <stdio.h>
#include <string.h>
#include "histogram.h"

#define ERR  -1
#define NORM 0
#define HST1 1
#define HST2 2
#define GATE 3
#define AND  4
#define OR   5
#define COMM 6
#define BBANA 7

static int h1id = 0, h2id = 0;
int mode;

int split_nstr(char *buff,char *str){
  char tbuff[256];
  int i,j,flag;

  flag = 0;
  j = 0;
  memset(tbuff,0,sizeof(tbuff));

  if(buff[0] == '\n' || buff[0] == 'c' || buff[0] == '#'){
    return COMM;
  }

  if(strlen(buff) < 5 && mode != BBANA){
    return COMM;
  }


  if(buff[strlen(buff)-1] == '\n'){
    buff[strlen(buff)-1] = '\0';
  }

  if(strcmp(buff,"hst1") == 0){
    return HST1;
  }else if(strcmp(buff,"hst2") == 0){
    return HST2;
  }else if(strcmp(buff,"gate") == 0){
    return GATE;
  }else if(strcmp(buff,"and") == 0){
    return AND;
  }else if(strcmp(buff,"or") == 0){
    return OR;
  }else if(strcmp(buff,"bbana") == 0){
    return BBANA;
  }

  for(i=0;i<strlen(buff);i++){
    if(flag == 1){
      str[j] = buff[i];
      j++;
    }
    if(buff[i] == '\''){
      if(flag == 0){
	tbuff[j-1] = '\0';
      }
      if(flag == 1){
	str[j-1] = '\0';
      }
      j = 0;
      flag++;
    }
    if(flag == 0){
      if(buff[i] != ' '){
	if(buff[i] == ','){
	  buff[i] = ' ';
	}
	tbuff[j] = buff[i];
	j++;
      }
    }
  }
  if(flag == 1){
    return ERR;
  }

  memset(buff,0,sizeof(buff));
  strcpy(buff,tbuff);

  return 0;
}

int mkhist(char *file,int *anaseg, struct hist1d *h1,struct hist2d *h2,
	   int *chsum, int *dchsum){
  FILE *fd;
  char buff[256],str[128];
  int gid;

  if((fd = fopen(file,"r")) == NULL){
    printf("Can't open %s\n",fd);
    return -1;
  }
  while(!feof(fd)){
    memset(buff,0,sizeof(buff));
    fgets(buff,sizeof(buff),fd);
    switch(split_nstr(buff,str)){
    case ERR:
      printf("Error in hst file.\n");
      return ERR;
      break;
    case COMM:
      mode = COMM;
      break;
    case HST1:
      mode = HST1;
      break;
    case HST2:
      mode = HST2;
      break;
    case GATE:
      mode = GATE;
      break;
    case AND:
      mode = AND;
      break;
    case OR:
      mode = OR;
      break;
    case BBANA:
      mode = BBANA;
      break;
    case NORM:
      switch(mode){
      case HST1:
	if(sscanf(buff,"%d %d %d %d %d",
		  &h1[h1id].gate,&h1[h1id].src,&h1[h1id].bin,
		  &h1[h1id].lower,&h1[h1id].upper) != 5){
	  return -1;
	}
	strncpy(h1[h1id].name,str,64);
	h1[h1id].id = h1id;
	h1[h1id].src--;
	h1id++;
	break;
      case HST2:
	if(sscanf(buff,"%d %d %d %d %d %d %d %d %d",
		  &h2[h2id].gate,&h2[h2id].xsrc,&h2[h2id].ysrc,
		  &h2[h2id].xbin,&h2[h2id].xlower,&h2[h2id].xupper,
		  &h2[h2id].ybin,&h2[h2id].ylower,&h2[h2id].yupper
		  ) != 9){
	  return -1;
	}
	strncpy(h2[h2id].name,str,64);
	h2[h2id].id = h2id;
	h2[h2id].xsrc--;
	h2[h2id].ysrc--;
	h2id++;
	break;
      case BBANA:
	if(sscanf(buff,"%d",anaseg) != 1){
	  return -1;
	}
      }
    }
  }
  fclose(fd);

  *chsum = h1id;
  *dchsum = h2id;

  return 0;
}
