int cx2bin(int x){
  int ret,hbin;

  hbin = hinfo[chid].wun - hinfo[chid].wln;
  ret = x*hbin/cw + hinfo[chid].wln;

  return ret;
}

int dcx2bin(int x){
  int ret,dhbin;

  dhbin = dhinfo[dchid].xun - dhinfo[dchid].xln;
  ret = x*dhbin/dcw + dhinfo[dchid].xln;

  return ret;
}

int dcy2bin(int y){
  int ret,dhbin;

  dhbin = dhinfo[dchid].yun - dhinfo[dchid].yln;
  ret = y*dhbin/dch + dhinfo[dchid].yln;

  return ret;
}

int bin2val(struct hist1d *hist,int x){
  int ret;

  ret = (hist->upper - hist->lower)*x/hist->bin;

  return ret;
}

int dxbin2val(struct hist2d *hist,int x){
  int ret;

  ret = (hist->xupper - hist->xlower)*x/hist->xbin;

  return ret;
}

int dybin2val(struct hist2d *hist,int y){
  int ret;

  ret = (hist->yupper - hist->ylower)*y/hist->ybin;

  return ret;
}


int dstep(int cnt,int mode){
  int ret;
  /* mode
     0 : step 5
     1 : step 10
     2 : step 50
     3 : step 100
     4 : log10
  */
  switch(mode){
  case 0:
    ret = cnt/5;
    break;
  case 1:
    ret = cnt/10;
    break;
  case 2:
    ret = cnt/50;
    break;
  case 3:
    ret = cnt/100;
    break;
  case 4:
    ret = -1;
    while(cnt > 0 || ret < 10){
      cnt /= 10;
      ret++;
    }
    break;
  }
  if(ret > 9){
    ret = 9;
  }
  return ret;

}

int calcLog(int x){
  int log10[] = {0,0,0,0,0,0,0,0,0,0,0,
		 2,4,6,7,9,10,12,13,14,15,
		 16,17,18,19,20,21,22,22,23,24,
		 25,25,26,27,27,28,28,29,30,30,
		 31,31,32,32,33,33,34,34,35,35,
		 35,36,36,37,37,37,38,38,39,39,
		 39,40,40,40,41,41,41,42,42,42,
		 43,43,43,43,44,44,44,45,45,45,
		 45,46,46,46,46,47,47,47,47,48,
		 48,48,48,49,49,49,49,50,50,50};
  if(x <= 10){
    return log10[x*10];
  }else if(x <= 100){
    return 50+log10[x];
  }else if(x <= 1000){
    return 100+log10[x/10];
  }else if(x <= 10000){
    return 150+log10[x/100];
  }else if(x <= 100000){
    return 200+log10[x/1000];
  }else if(x <= 1000000){
    return 250+log10[x/10000];
  }else{
    return 500;
  }
}

int calcArea(struct hist1d *hist,int lb,int ub){
  int sum=0,i;

  for(i=lb;i<=ub;i++){
    sum = sum + hist->data[i];
  }

  printf("\n");
  printf("%s (%d-%d)\n",hist->name,bin2val(hist,lb),bin2val(hist,ub));
  printf("  Sum %d\n",sum);

  return 0;
}
