import java.awt.*;
import java.awt.event.*;

class HistCanvas extends Canvas
    implements MouseListener,MouseMotionListener{

    private int canNumber,mode;
    private boolean dragBoolean,logBoolean;
    private int[] dragPosition;

    public HistCanvas(int number){
        canNumber = number;
        addMouseListener(this);
        addMouseMotionListener(this);
        dragBoolean = false;
        dragPosition = new int[2];
        this.setBackground(Color.white);
        this.setBounds(30,50,512,270);

    }

    public void paint(Graphics g){
        update(g);
    }
    
    public void update(Graphics g){
        int chwide,j,chbottom,chsize,cntsize,cntbottom;

        mode = StartupDAQ.conFrame.histFrame[canNumber].getPlotMode();
        logBoolean = StartupDAQ.conFrame.histFrame[canNumber].checklogHist();

        g.clearRect(0,0,512,270);
        chwide = StartupDAQ.conFrame.paramhist[canNumber].getchwide();
        chbottom = StartupDAQ.conFrame.paramhist[canNumber].getchbottom();
        j = chbottom;
        cntsize = StartupDAQ.conFrame.paramhist[canNumber].getcntsize();
        if(logBoolean == true){
            cntbottom = 0;
            g.setColor(Color.lightGray);
            for(int i=0;i<260;i+=50){
                g.drawLine(0,270-i,512,270-i);
            }
        }else{
            cntbottom = StartupDAQ.conFrame.paramhist[canNumber].getcntbottom();
        }

        String channel,count;
        int chpoint;
        chpoint = StartupDAQ.conFrame.paramhist[canNumber].getchpoint();
        channel = Integer.toString(chpoint);
        count = Integer.toString(StartupDAQ.conFrame.histdata[canNumber].getData(chpoint));
        g.setColor(Color.black);
        g.drawString(" ch:" + channel,460,10);
        g.drawString("cnt:" + count,460,20);

        g.setColor(Color.blue);

        /* Paint histgram */
        if(chwide >= 512){
            int y,yy,data11,data12,dd1,dd2;
            int tcnt1,tcnt2;
            chsize = chwide/512;
            /* Line and Poll Mode */
            if(mode == 0 || mode == 2){
                dd1 = StartupDAQ.conFrame.histdata[canNumber].getData(j);
                dd2 = StartupDAQ.conFrame.histdata[canNumber].getData(j+chsize);
                for(int i=0;i<511;i++){
                    if(i == 0){
                        for(int k=1;k<chsize;k++){
                            if(StartupDAQ.conFrame.histdata[canNumber].getData(j+k) > dd1){
                                dd1 = StartupDAQ.conFrame.histdata[canNumber].getData(j+k);
                            }
                        }
                        for(int k=1;k<chsize;k++){
                            if(StartupDAQ.conFrame.histdata[canNumber].getData(j+chsize+k) > dd2){
                                dd2 = StartupDAQ.conFrame.histdata[canNumber].getData(j+chsize+k);
                            }
                        }
                    }else{
                        dd1 = dd2;
                        dd2 = StartupDAQ.conFrame.histdata[canNumber].getData(j+chsize);
                        for(int k=1;k<chsize;k++){
                            if(StartupDAQ.conFrame.histdata[canNumber].getData(j+chsize+k) > dd2){
                                dd2 = StartupDAQ.conFrame.histdata[canNumber].getData(j+chsize+k);
                            }
                        }
                    }
                    if(logBoolean == true){
                        data11 = calcLog(dd1);
                        data12 = calcLog(dd2);
                    }else{
                        data11 = dd1/cntsize;
                        data12 = dd2/cntsize;
                    }
                    y = 270 + cntbottom - data11;
                    yy = 270 + cntbottom - data12;
                    if(y < 0){
                        y = 0;
                    }
                    if(yy < 0){
                        yy = 0;
                    }

                    if(mode == 0){
                        g.drawLine(i,y,i+1,yy);
                    }else if(mode == 2){
                        g.drawLine(i,y,i,270);
                        if(i == 511){
                            g.drawLine(i+1,yy,i+1,270);
                        }
                    }
                    j += chsize;
                }
            }
            /* Dot mode */
            if(mode == 1){
                for(int i=0;i<512;i++){
                    for(int k=0;k<chsize;k++){
                        dd1 = StartupDAQ.conFrame.histdata[canNumber].getData(j+k);
                        if(logBoolean == true){
                            data11 = calcLog(dd1);
                        }else{
                            data11 = dd1/cntsize;
                        }
                        y = 270 + cntbottom - data11;
                        if(y < 0){
                            y = 0;
                        }
                        g.fillRect(i,y,1,1);
                    }
                    j += chsize;
                }
            }
        }else if(chwide < 512){
            int i=0,y,yy,data0,data11,data12,dd0,dd1,dd2;
            chsize = 512/chwide;
            dd2 = StartupDAQ.conFrame.histdata[canNumber].getData(j);
            if(StartupDAQ.conFrame.histFrame[canNumber].checklogHist() == true){
                data0 = calcLog(dd2);
            }else{
                data0 = dd2/cntsize;
            }
            g.drawLine(0,270,0,270+cntbottom-data0);

            while(j < chbottom + chwide -1){
                dd1 = dd2;
                dd2 = StartupDAQ.conFrame.histdata[canNumber].getData(j+1);
                if(StartupDAQ.conFrame.histFrame[canNumber].checklogHist() == true){
                    data11 = calcLog(dd1);
                    data12 = calcLog(dd2);
                }else{
                    data11 = dd1/cntsize;
                    data12 = dd2/cntsize;
                }
                y = 270 + cntbottom - data11;
                yy = 270 + cntbottom - data12;
                if(y < 0){
                    y = 0;
                }
                if(yy < 0){
                    yy = 0;
                }
                if(mode == 2){
                    if(y != 0){
                        g.fillRect(i,y,chsize,270-y);
                    }else{
                        g.fillRect(i,0,chsize,270);
                    }
                }else{
                    g.drawLine(i,y,i+chsize,y);
                    g.drawLine(i+chsize,y,i+chsize,yy);
                }
                i += chsize;
                j += 1;
            }
        }
        if(StartupDAQ.conFrame.paramhist[canNumber].curCheckbox0.getState() == true){
            int curtop,curbottom;
            curtop = StartupDAQ.conFrame.paramhist[canNumber].getcur("top",0)-chbottom+1;
            curbottom = StartupDAQ.conFrame.paramhist[canNumber].getcur("bottom",0)-chbottom;
            if(chwide >= 512){
                chsize = chwide/512;
                curtop /= chsize;
                curbottom /= chsize;
            }else{
                chsize = 512/chwide;
                curtop *= chsize;
                curbottom *= chsize;
            }
            g.setXORMode(Color.cyan);
            g.drawLine(curtop,0,curtop,270);
            g.drawLine(curbottom,0,curbottom,270);
            StartupDAQ.conFrame.paramhist[canNumber].curCountSum();
        }
    }

    /* histCanvas MouseListener */
    public void mouseEntered(MouseEvent evt){
    }

    public void mouseExited(MouseEvent evt){
    }

    public void mouseClicked(MouseEvent evt){
        int xx,chwide,chbottom,cb,xcenter,ccount;
        xx = evt.getX();
        ccount = evt.getClickCount();

        switch(ccount){
        case 1:
            StartupDAQ.conFrame.paramhist[canNumber].setchpoint(xx);
            repaint();
            break;
        case 2:
            chwide = StartupDAQ.conFrame.paramhist[canNumber].getchwide();
            chbottom = StartupDAQ.conFrame.paramhist[canNumber].getchbottom();
            xcenter = chbottom + chwide*xx/512;
            cb = xcenter - chwide/4;
            StartupDAQ.conFrame.paramhist[canNumber].downchwide();
            StartupDAQ.conFrame.paramhist[canNumber].setchbottom(cb);
            repaint();
            StartupDAQ.conFrame.histFrame[canNumber].repaint();
            StartupDAQ.conFrame.paramhist[canNumber].setchChoice();
            break;
        }
    }

    public void mousePressed(MouseEvent evt){
        dragPosition[0] = StartupDAQ.conFrame.paramhist[canNumber].getPoint(evt.getX());        
    }

    public void mouseReleased(MouseEvent evt){
        int endX;
        if(dragBoolean == true){
            dragPosition[1] = StartupDAQ.conFrame.paramhist[canNumber].getPoint(evt.getX());
            if(dragPosition[0] > dragPosition[1]){
                int tmp;
                tmp = dragPosition[0];
                dragPosition[0] = dragPosition[1];
                dragPosition[1] = tmp;
            }
            StartupDAQ.conFrame.paramhist[canNumber].setcur("top",0,dragPosition[1]);
            StartupDAQ.conFrame.paramhist[canNumber].setcur("bottom",0,dragPosition[0]);
            this.repaint();
            dragBoolean = false;
        }
    }

    int calcLog(int x){
        int[] log10 = {0,0,0,0,0,0,0,0,0,0,0,
                       2,4,6,7,9,10,12,13,14,15,
                       16,17,18,19,20,21,22,22,23,24,
                       25,25,26,27,27,28,28,29,30,30,
                       31,31,32,32,33,33,34,34,35,35,
                       35,36,36,37,37,37,38,38,39,39,
                       39,40,40,40,41,41,41,42,42,42,
                       43,43,43,43,44,44,44,45,45,45,
                       45,46,46,46,46,47,47,47,47,48,
                       48,48,48,49,49,49,49,50,50,50};
        if(x <= 10){
            return log10[x*10];
        }else if(x <= 100){
            return 50+log10[x];
        }else if(x <= 1000){
            return 100+log10[x/10];
        }else if(x <= 10000){
            return 150+log10[x/100];
        }else if(x <= 100000){
            return 200+log10[x/1000];
        }else if(x <= 1000000){
            return 250+log10[x/10000];
        }else{
            return 500;
        }
    }

    /* Mouse Motion Listener */
    public void mouseDragged(MouseEvent evt){
        dragBoolean = true;
    }

    public void mouseMoved(MouseEvent evt){
    }

}

