/* On-Line Histogram */

import java.awt.*;
import java.awt.event.*;

public class Histogram extends Frame
		implements ActionListener,WindowListener,ItemListener{

    private int histNumber,plotmode;
    private Checkbox linCheckbox,logCheckbox,plotCheckbox[];
    CheckboxGroup modeGroup,plotGroup;
	Color histColor;
	Button cntwideButton,cntnarrowButton,paramButton,wideButton,opButton;

	public Histogram(int number){
        histNumber = number;
        plotmode = 0;
        this.setBackground(Color.lightGray);
        this.setSize(550,350);
		this.setFont(StartupDAQ.defaultFont);
        this.setTitle("Histogram "+StartupDAQ.conFrame.histdata[histNumber].getName());

		histColor = new Color(0xff,0xff,0xcc);
		addWindowListener(this);

		/* GUI */
		this.setLayout(null);
		cntwideButton = new Button("Short");
		cntnarrowButton = new Button("Tall");
        paramButton = new Button("Parameter");
        wideButton = new Button("Wide");
		opButton = new Button("Operate");
        modeGroup = new CheckboxGroup();
        linCheckbox = new Checkbox("Linear",true,modeGroup);
        logCheckbox = new Checkbox("Log",false,modeGroup);
        plotGroup = new CheckboxGroup();
        plotCheckbox = new Checkbox[3];
        plotCheckbox[0] = new Checkbox("Line",true,plotGroup);
        plotCheckbox[1] = new Checkbox("Dot",false,plotGroup);
        plotCheckbox[2] = new Checkbox("Poll",false,plotGroup);
        for(int i=0;i<3;i++){
            plotCheckbox[i].setBackground(Color.pink);
        }

		/* GUIs setBounds */
		cntwideButton.setBounds(60,25,30,20);
		cntnarrowButton.setBounds(90,25,30,20);
        paramButton.setBounds(10,25,50,20);
        wideButton.setBounds(120,25,30,20);
        linCheckbox.setBounds(150,25,60,20);
        logCheckbox.setBounds(210,25,60,20);
        plotCheckbox[0].setBounds(270,25,60,20);
        plotCheckbox[1].setBounds(330,25,60,20);
        plotCheckbox[2].setBounds(390,25,60,20);
		opButton.setBounds(450,25,60,20);
		opButton.setBackground(Color.green);

		cntwideButton.setForeground(Color.blue);
		cntnarrowButton.setForeground(Color.blue);
        paramButton.setForeground(Color.blue);
        wideButton.setForeground(Color.blue);

		this.add(StartupDAQ.conFrame.histcanvas[histNumber]);
		this.add(cntwideButton);
		this.add(cntnarrowButton);
        this.add(paramButton);
        this.add(wideButton);
        this.add(linCheckbox);
        this.add(logCheckbox);
        for(int i=0;i<3;i++){
            this.add(plotCheckbox[i]);
        }
		this.add(opButton);

		/* Add GUIs to ActionListener */
		cntwideButton.addActionListener(this);
		cntnarrowButton.addActionListener(this);
        paramButton.addActionListener(this);
        wideButton.addActionListener(this);
		opButton.addActionListener(this);

        /* Add GUIs to ItemListener */
        linCheckbox.addItemListener(this);
        logCheckbox.addItemListener(this);
        for(int i=0;i<3;i++){
            plotCheckbox[i].addItemListener(this);
        }
	}


    public int getPlotMode(){
        return plotmode;
    }

	/* Paint histFrame */
	public void paint(Graphics g){
		g.drawLine(30,320,542,320);
		g.drawLine(29,50,29,320);
		update(g);
	}

	public void update(Graphics g){
		int chtop,chbottom,cnttop,cntbottom,chwide,cntsize;
        chwide = StartupDAQ.conFrame.paramhist[histNumber].getchwide();
		chbottom = StartupDAQ.conFrame.paramhist[histNumber].getchbottom();
		chtop = chbottom + chwide -1;
        cntsize = StartupDAQ.conFrame.paramhist[histNumber].getcntsize();
		cntbottom = StartupDAQ.conFrame.paramhist[histNumber].getcntbottom();
        cnttop = cntbottom + (cntsize*256) - 1;
        
		g.clearRect(20,322,527,20);
		g.clearRect(0,50,29,280);
        g.drawString(Integer.toString(chtop),520,330);
        g.drawString(Integer.toString(chbottom),35,330);
        if(StartupDAQ.conFrame.histFrame[histNumber].logCheckbox.getState() == true){
            g.drawString("10",7,270);
            g.drawString("10",7,220);
            g.drawString("2",18,218);
            g.drawString("10",7,170);
            g.drawString("3",18,168);
            g.drawString("10",7,120);
            g.drawString("4",18,118);
            g.drawString("10",7,70);
            g.drawString("5",18,68);
        }else{
            g.drawString(Integer.toString(cnttop),10,60);
            g.drawString(Integer.toString(cntbottom),10,315);
        }
        //StartupDAQ.conFrame.histcanvas[histNumber].repaint();
	}

    /* lin or log */
    public boolean checklogHist(){
        return logCheckbox.getState();
    }

	/* Check TextFields */
	public boolean checkHist(String chString){
		int j=0;
		for(int i=0;i<chString.length();i++){
			if(Character.isDigit(chString.charAt(i)) == false){
				j++;
			}
		}
		if(j == 0){
			return true;
		}else{
			return false;
		}
	}

	/* Hist ActionListener */
	public void actionPerformed(ActionEvent evt){
		Object obj = evt.getSource();
		int value;

		if(obj == cntwideButton){
			StartupDAQ.conFrame.paramhist[histNumber].upcntsize();
			StartupDAQ.conFrame.histcanvas[histNumber].repaint();
            StartupDAQ.conFrame.paramhist[histNumber].setcntChoice();
            repaint();
		}
		if(obj == cntnarrowButton){
			StartupDAQ.conFrame.paramhist[histNumber].downcntsize();
			StartupDAQ.conFrame.histcanvas[histNumber].repaint();
            StartupDAQ.conFrame.paramhist[histNumber].setcntChoice();
            repaint();
		}
		if(obj == paramButton){
            //StartupDAQ.conFrame.paramhist[histNumber].setLocation(300,10*histNumber+300);
            StartupDAQ.conFrame.paramhist[histNumber].show();
		}
        if(obj == wideButton){
            StartupDAQ.conFrame.paramhist[histNumber].setchwide(StartupDAQ.conFrame.histdata[histNumber].getScale());
            StartupDAQ.conFrame.histcanvas[histNumber].repaint();
            StartupDAQ.conFrame.paramhist[histNumber].setchChoice();
            repaint();
        }
        if(obj == opButton){
			new MakeOperatePoint(histNumber);
		}
	}

	/* Hist ItemListener */
	public void itemStateChanged(ItemEvent evt){
		Object obj = evt.getSource();

        if(obj == linCheckbox || obj == logCheckbox){
            repaint();
            StartupDAQ.conFrame.histcanvas[histNumber].repaint();
        }
        for(int i=0;i<3;i++){
            if(obj == plotCheckbox[i]){
                plotmode = i;
                StartupDAQ.conFrame.histcanvas[histNumber].repaint();
            }
        }
	}

	/* Hist WindowLintener */
	public void windowClosed(WindowEvent evt){
	}

	public void windowClosing(WindowEvent evt){
		dispose();
	}

	public void windowOpened(WindowEvent evt){
	}

	public void windowIconified(WindowEvent evt){
	}

	public void windowDeiconified(WindowEvent evt){
	}

	public void windowActivated(WindowEvent evt){
	}

	public void windowDeactivated(WindowEvent evt){
	}

public void getHistNumber(){
    System.out.println(Integer.toString(histNumber));
}
}
