import java.awt.*;
import java.awt.event.*;

public class MakeGatedHist extends Frame
    implements ActionListener,WindowListener{

    Choice gateChoice,sizeChoice;
    TextField nameTF;
    Button okButton,cancelButton;

    MakeGatedHist(int n){
        this.setTitle("Make Gated Histogram");
        this.setFont(StartupDAQ.defaultFont);
        this.addWindowListener(this);
        Panel apanel = new Panel(new GridLayout(0,3));
        Panel bpanel = new Panel();

        apanel.add(new Label("Gate",Label.CENTER));
        apanel.add(new Label("Size",Label.CENTER));
        apanel.add(new Label("Name",Label.CENTER));

        gateChoice = new Choice();
        sizeChoice = new Choice();
        for(int i=0;i<StartupDAQ.conFrame.gateNum;i++){
            gateChoice.add(StartupDAQ.conFrame.gate[i].getName());
        }
        sizeChoice.add("2048");
        sizeChoice.add("4096");
        sizeChoice.add("65536");
        nameTF = new TextField("Hist-"+Integer.toString(n));
        okButton = new Button("Make Hist");
        cancelButton = new Button("Cancel");
        okButton.addActionListener(this);
        cancelButton.addActionListener(this);

        apanel.add(gateChoice);
        apanel.add(sizeChoice);
        apanel.add(nameTF);
        bpanel.add(okButton);
        bpanel.add(cancelButton);

        this.add(apanel,"Center");
        this.add(bpanel,"South");
        this.pack();
        this.show();
    }

    public void actionPerformed(ActionEvent evt){
        Object obj = evt.getSource();
        if(obj == okButton){
            int gate,size;
            String name,b;
            gate = gateChoice.getSelectedIndex();
            b = sizeChoice.getSelectedItem();
            size = 0;
            if(b == "2048"){
                size = 11;
            }else if(b == "4096"){
                size = 12;
            }else if(b == "65536"){
                size = 16;
            }
            name = nameTF.getText();
            StartupDAQ.conFrame.addGatedHist(name,gate,size);
        }
        dispose();
    }

	/* WindowLintener */
	public void windowClosed(WindowEvent evt){
	}

	public void windowClosing(WindowEvent evt){
		dispose();
	}

	public void windowOpened(WindowEvent evt){
	}

	public void windowIconified(WindowEvent evt){
	}

	public void windowDeiconified(WindowEvent evt){
	}

	public void windowActivated(WindowEvent evt){
	}

	public void windowDeactivated(WindowEvent evt){
	}
}
