import java.awt.*;
import java.awt.event.*;

public class MakeTwodim extends Frame
    implements ActionListener,WindowListener{

    Choice xChoice,yChoice,intervalChoice;
    CheckboxGroup sizeGroup,scaleGroup;
    Checkbox[] sizeCheckbox,scaleCheckbox;
    Panel makePanel,makePanel2;
    Label[] makeLabel;
    Button[] makeButton;
    TextField nameTF;

    public MakeTwodim(){
        this.setTitle("Make 2D Graph");
        this.setFont(StartupDAQ.defaultFont);
        this.setBackground(Color.lightGray);

        makePanel = new Panel(new GridLayout(0,3));
        makePanel2 = new Panel(new GridLayout(0,2));
        makeLabel = new Label[8];
        makeLabel[0] = new Label("");
        makeLabel[1] = new Label("X array",Label.CENTER);
        makeLabel[2] = new Label("Y array",Label.CENTER);
        makeLabel[3] = new Label("Data",Label.CENTER);
        makeLabel[4] = new Label("Size",Label.CENTER);
        makeLabel[5] = new Label("Scale",Label.CENTER);
        makeLabel[6] = new Label("Color Inteval",Label.CENTER);
        makeLabel[7] = new Label("Name",Label.CENTER);
        xChoice = new Choice();
        yChoice = new Choice();
        intervalChoice = new Choice();
        for(int i=0;i<StartupDAQ.conFrame.dataNum;i++){
            xChoice.add(StartupDAQ.conFrame.histdata[i].getName());
            yChoice.add(StartupDAQ.conFrame.histdata[i].getName());
        }
        for(int i=0;i<StartupDAQ.conFrame.gateNum;i++){
            xChoice.add(StartupDAQ.conFrame.gate[i].getName());
            yChoice.add(StartupDAQ.conFrame.gate[i].getName());
        }
        
        intervalChoice.add("50");
        intervalChoice.add("100");
        intervalChoice.add("200");
        intervalChoice.add("500");
        intervalChoice.add("1000");
        intervalChoice.add("NLog");
        intervalChoice.add("Log");
        sizeGroup = new CheckboxGroup();
        sizeCheckbox = new Checkbox[3];
        sizeCheckbox[0] = new Checkbox("512",sizeGroup,false);
        sizeCheckbox[1] = new Checkbox("384",sizeGroup,true);
        sizeCheckbox[2] = new Checkbox("256",sizeGroup,true);
        //sizeCheckbox[1].setEnabled(false);
        scaleGroup = new CheckboxGroup();
        scaleCheckbox = new Checkbox[2];
        scaleCheckbox[0] = new Checkbox("Auto",scaleGroup,true);
        scaleCheckbox[1] = new Checkbox("1/1",scaleGroup,false);
        makeButton = new Button[2];
        makeButton[0] = new Button("Make 2D");
        makeButton[1] = new Button("Cancel");
        makeButton[0].addActionListener(this);
        makeButton[1].addActionListener(this);
        nameTF = new TextField();
        makePanel.add(makeLabel[0]);
        makePanel.add(makeLabel[1]);
        makePanel.add(makeLabel[2]);
        makePanel.add(makeLabel[3]);
        makePanel.add(xChoice);
        makePanel.add(yChoice);
        /*makePanel.add(makeLabel[4]);*/
        makePanel.add(sizeCheckbox[0]);
        makePanel.add(sizeCheckbox[1]);
        makePanel.add(sizeCheckbox[2]);
        makePanel.add(makeLabel[5]);
        makePanel.add(scaleCheckbox[0]);
        makePanel.add(scaleCheckbox[1]);
        makePanel2.add(makeLabel[6]);
        makePanel2.add(intervalChoice);
        makePanel2.add(makeLabel[7]);
        makePanel2.add(nameTF);
        makePanel2.add(makeButton[0]);
        makePanel2.add(makeButton[1]);
        this.add(makePanel,"North");
        this.add(makePanel2,"Center");
        this.pack();


        addWindowListener(this);
        this.setVisible(true);
    }



	/* ActionListener */
	public void actionPerformed(ActionEvent evt){
		Object obj = evt.getSource();
        if(obj == makeButton[0]){
            int x,y,size,interval,sc;
            String name;
            sc = 0;
            x = xChoice.getSelectedIndex();
            y = yChoice.getSelectedIndex();
            size = Integer.parseInt(sizeGroup.getSelectedCheckbox().getLabel());
            interval = intervalChoice.getSelectedIndex();
            name = nameTF.getText();
            if(name.length() == 0){
                name = xChoice.getSelectedItem()+"-"+yChoice.getSelectedItem();
            }
            Checkbox cc = scaleGroup.getSelectedCheckbox();
            if(cc == scaleCheckbox[0]){
                sc = 0;
            }else if(cc == scaleCheckbox[1]){
                sc = 1;
            }
            StartupDAQ.conFrame.make2D(x,y,size,sc,name,interval);
        }
        dispose();
    }


	/* WindowLintener */
	public void windowClosed(WindowEvent evt){
	}

	public void windowClosing(WindowEvent evt){
		dispose();
	}

	public void windowOpened(WindowEvent evt){
	}

	public void windowIconified(WindowEvent evt){
	}

	public void windowDeiconified(WindowEvent evt){
	}

	public void windowActivated(WindowEvent evt){
	}

	public void windowDeactivated(WindowEvent evt){
	}
}
