import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.text.*;
import java.net.*;

public class NControlDAQ extends Frame
    implements Runnable,ActionListener,WindowListener,ItemListener{
    public static DimData[] dimdata;
    public static Point[] dimpoint;
    public static HistData[] histdata;
    public static Histogram[] histFrame;
    public static HistCanvas[] histcanvas;
    public static ParamHist[] paramhist;
    public static int dataNum,dimNum,histNum,gateNum;
    public static String runName,driverPath;
    public static Twodim[] twodimFrame;
    public static int[] inputdata;
    public static boolean alertflag = false;
    public static GateData[] gate;
    public static Scaler scalerFrame;
    public static ScalerData[] scalerdata;
    public static Threedim[] threedim;
    public static int threeDimNum = 3;

    DatagramSocket socket;
    DatagramPacket packet;

    long runTime,suspendTime,eventCounter;
    Date startDate,stopDate,runDate;
    DateFormat dateformat;
    SimpleDateFormat simpledateformat;
    Label startLabel,stopLabel,eventLabel,eventstLabel,runNumberLabel;
    AlertDialog alertdi;
    boolean saveFlag;
    String fifoPath;
    Thread readThread;
    Button runButton;
    Panel conPanel,datePanel;
    byte[] log,logbyte;
    MenuItem quitItem,saveItem,clearItem,addOpenItem,
             safeOpenItem,openItem,makeDimItem,clearGraphItem,helpItem,
             makeGateItem,gatedHistItem,oldopenItem,scalerItem;
    MenuItem[] histItem,dimItem,printHistItem,printDimItem,
    		   printThreeDimItem,saveHistItem,saveDimItem,
    		   threeDimItem;
    Menu dimSubMenu,histSubMenu,printDimSubMenu,saveHistSubMenu,
         saveDimSubMenu,printHistSubMenu,printThreeDimSubMenu,
         printMenu,fileMenu,
         graphMenu,extendMenu,scalerMenu,threeDimSubMenu;
    FileOutputStream writelog;
    boolean logboolean = false;
    FileDialog saveDialog,openDialog;
    Frame saveFrame;
    int sleepTime,size,runcounter;
    File countFile,infoFile;


	public NControlDAQ(){
		int scsum;

		this.setTitle("Online Monitor for babaDAQ");

		this.setSize(300,150);
		//setBackground(new Color(0xcc,0x99,0xcc));
        //setLocation(30,0);
		addWindowListener(this);
		this.setFont(StartupDAQ.defaultFont);
        dimdata = new DimData[50];
        dimpoint = new Point[50];
        twodimFrame = new Twodim[50];
        inputdata = new int[50];
		conPanel = new Panel();

        eventCounter = 0;
        /* Date */
        dateformat = DateFormat.getDateTimeInstance(DateFormat.SHORT,DateFormat.MEDIUM);
        startLabel = new Label("Start : 00/00/00 00:00:00",Label.CENTER);
        stopLabel = new Label("Stop : 00/00/00 00:00:00",Label.CENTER);
        simpledateformat = new SimpleDateFormat("HH:mm:ss:SSS",Locale.US);

        runNumberLabel = new Label("Run = 00",Label.CENTER);
        runNumberLabel.setBackground(Color.yellow);
        eventLabel = new Label("---------",Label.CENTER);
        eventLabel.setBackground(Color.orange);
        eventstLabel = new Label("Event Total",Label.CENTER);
        eventstLabel.setBackground(Color.orange);
        Panel eventPanel = new Panel(new FlowLayout(FlowLayout.CENTER,0,5));
        eventPanel.add(runNumberLabel);
        eventPanel.add(eventstLabel);
        eventPanel.add(eventLabel);
        this.add(eventPanel,"Center");

        datePanel = new Panel();
        startLabel.setBackground(Color.cyan);
        stopLabel.setBackground(Color.cyan);
        datePanel.add(startLabel);
        datePanel.add(stopLabel);
        this.add(datePanel,"North");

        /* File */
        countFile = new File("./count.txt");
        infoFile = new File("./datainfo.txt");

        /* Set of RunCounter */
        if(countFile.exists() == true){
            try{
                BufferedReader filein = new BufferedReader(new FileReader(countFile));
                runcounter = Integer.parseInt(filein.readLine());
                filein.close();
                runNumberLabel.setText("Run = "+Integer.toString(runcounter));
            }catch(IOException e){
                System.out.println("Cought IOException runcounter");
            }
        }else{
            runcounter = 1;
            runNumberLabel.setText("Run = "+Integer.toString(runcounter));
        }


        /* Histogram and Gate */
        gate = new GateData[50];
        gateNum = 0;
        paramhist = new ParamHist[50];
        histcanvas = new HistCanvas[50];
        histFrame = new Histogram[50];
        histdata = new HistData[50];
        histNum = dataNum;

        for(int i=0;i<dataNum;i++){
            histcanvas[i] = new HistCanvas(i);
            histdata[i] = new HistData(StartupDAQ.dataNameST[i],i,StartupDAQ.dataBit[i]);
            histFrame[i] = new Histogram(i);
            paramhist[i] = new ParamHist(i);
        }

        /* Scaler Menu */
        scalerMenu = new Menu("Scaler");
        scalerItem = new MenuItem("Scaler");
        scalerItem.addActionListener(this);
        scalerMenu.add(scalerItem);

        fileMenu = new Menu("File");
        saveItem = new MenuItem("Save");
        clearItem = new MenuItem("Data Clear");

        openItem = new MenuItem("Open");
		addOpenItem = new MenuItem("Add Open");
        safeOpenItem = new MenuItem("Safe Open");
        oldopenItem = new MenuItem("Old Open");
		quitItem = new MenuItem("Quit");

        printMenu = new Menu("Print");
        printHistSubMenu = new Menu("Histogram");
        printDimSubMenu = new Menu("2D");
        printThreeDimSubMenu = new Menu("3D");

        /* Extended Series */
        extendMenu = new Menu("Extend");
        makeGateItem = new MenuItem("Make Gate");
        makeGateItem.addActionListener(this);
        extendMenu.add(makeGateItem);
        gatedHistItem = new MenuItem("Gated Histogram");
        gatedHistItem.addActionListener(this);
        extendMenu.add(gatedHistItem);


        /* Help Series */
        Menu helpMenu = new Menu("Help");
        helpItem = new MenuItem("About...");
        helpItem.addActionListener(this);
        helpMenu.add(helpItem);
        helpItem.setEnabled(false);

		histSubMenu = new Menu("Histogram");
        saveHistSubMenu = new Menu("Save Hist");
        saveDimSubMenu = new Menu("Save 2D");
		histItem = new MenuItem[50];
        printHistItem = new MenuItem[50];
        saveHistItem = new MenuItem[50];
        saveDimItem = new MenuItem[50];
        for(int i=0;i<dataNum;i++){
            histItem[i] = new MenuItem(histdata[i].getName());
            printHistItem[i] = new MenuItem(histdata[i].getName());
            saveHistItem[i] = new MenuItem(histdata[i].getName());
            histSubMenu.add(histItem[i]);
            saveHistSubMenu.add(saveHistItem[i]);
            printHistSubMenu.add(printHistItem[i]);
            histItem[i].addActionListener(this);
            printHistItem[i].addActionListener(this);
            saveHistItem[i].addActionListener(this);
        }

        //fileMenu.add(saveItem);
        fileMenu.add(clearItem);
        fileMenu.add(saveHistSubMenu);
        fileMenu.add(saveDimSubMenu);
        fileMenu.add(openItem);
		fileMenu.add(addOpenItem);
        fileMenu.add(safeOpenItem);
        fileMenu.add(oldopenItem);
        fileMenu.add(new MenuItem("-"));
        fileMenu.add(quitItem);
        clearItem.addActionListener(this);
        clearItem.setEnabled(false);
        //saveItem.addActionListener(this);
        saveItem.setEnabled(false);
        saveHistSubMenu.setEnabled(false);
        saveDimSubMenu.setEnabled(false);
        openItem.addActionListener(this);
		addOpenItem.addActionListener(this);
        safeOpenItem.addActionListener(this);
        oldopenItem.addActionListener(this);

        clearGraphItem = new MenuItem("Graph Clear");
        clearGraphItem.addActionListener(this);

        dimSubMenu = new Menu("2D");
        dimItem = new MenuItem[50];
        printDimItem = new MenuItem[50];
		printThreeDimItem = new MenuItem[threeDimNum];

		threeDimSubMenu = new Menu("3D");
		threeDimItem = new MenuItem[threeDimNum];
		threedim = new Threedim[threeDimNum];
		for(int i=0;i<threeDimNum;i++){
			threedim[i] = new Threedim(i);
			threeDimItem[i] = new MenuItem("3D-"+Integer.toString(i));
			printThreeDimItem[i] = new MenuItem("3D-"+Integer.toString(i));
			threeDimSubMenu.add(threeDimItem[i]);
			printThreeDimSubMenu.add(printThreeDimItem[i]);
			threeDimItem[i].addActionListener(this);
			printThreeDimItem[i].addActionListener(this);
		}

        printMenu.add(printHistSubMenu);
        printMenu.add(printDimSubMenu);
        printMenu.add(printThreeDimSubMenu);
        makeDimItem = new MenuItem("Make 2D Graph");
        makeDimItem.addActionListener(this);
        graphMenu = new Menu("Graph");
        graphMenu.add(makeDimItem);
        graphMenu.add(clearGraphItem);
        graphMenu.add(histSubMenu);
        graphMenu.add(dimSubMenu);
        graphMenu.add(threeDimSubMenu);
        MenuBar conBar = new MenuBar();
        conBar.add(fileMenu);
        conBar.add(graphMenu);
        conBar.add(extendMenu);
        conBar.add(scalerMenu);
        conBar.add(printMenu);
        conBar.add(helpMenu);
        setMenuBar(conBar);
        quitItem.addActionListener(this);

        runButton = new Button("Run");
        runButton.addActionListener(this);

        conPanel.add(runButton);
        this.add("South",conPanel);
        //this.pack();

        readThread = new Thread(this);

        /* FileDialog */
        saveFrame = new Frame();
        saveDialog = new FileDialog(saveFrame,"Data save",FileDialog.SAVE);
        openDialog = new FileDialog(saveFrame,"Open file",FileDialog.LOAD);

        /* net append */
        logbyte = new byte[61442];
        packet = new DatagramPacket(logbyte,61442);

        saveFlag = true;

        /* Scaler */
        scsum = StartupDAQ.scalerSum;
        scalerdata = new ScalerData[scsum];
        for(int i=0;i<scsum;i++){
            scalerdata[i] = new ScalerData(StartupDAQ.scalerName[i],i);
        }
        scalerFrame = new Scaler(scsum);
        if(scsum == 0){
            scalerItem.setEnabled(false);
        }

        //this.pack();
        this.show();
    }

    /* Print Graphics */
    public void printGraphics(Frame frame){
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        PrintJob job = toolkit.getPrintJob(frame,"Print Graphics",null);
        if(job != null){
            Graphics g = job.getGraphics();
            frame.printAll(g);
            g.dispose();
            job.end();
        }
    }


    int bbtoint(byte[] in){
        int r;
        r = (in[0]&0x000000ff)|((in[1]<<8)&0x0000ff00);
        return r;
    }

    int bbbbtoint(byte[] inn){
        int r;
        r = (inn[0]&0x000000ff)|((inn[1]<<8)&0x0000ff00)|
            ((inn[2]<<16)&0x00ff0000);
        return r;
    }

    /* Read data from File safe mode */
    long safeFileRead(String path){
        FileInputStream filein;
        int n,tmp;
        boolean sc = false;
        byte[] in,inn;
        long counter;
        counter = 0;
        n = 0;
        in = new byte[2];
        inn = new byte[4];
        try{
            filein = new FileInputStream(path);
            filein.read(in);
            while(true){
                if(bbtoint(in) == 0x0000ffff){
                    break;
                }
                if(bbtoint(in) == 0x0000){
                    filein.read(in);
                    filein.read(in);
                    /*counter += bbtoint(in);*/
                    filein.read(in);
                    while(bbtoint(in) == 0xcc77){
                        counter++;
                        filein.read(in);
                        for(n=0;n<dataNum;n++){
                            filein.read(in);
                            inputdata[n] = bbtoint(in);
                        }
                        n = countInputData(n);
                        filein.read(in);
                    }
                    filein.read(in);
                    if(bbtoint(in) == 0xaaaa || bbtoint(in) == 0xbbbb){
                        int ss;
                        sc = true;
                        if(bbtoint(in) == 0xaaaa){
                            filein.read(in);
                            ss = bbtoint(in);;
                            for(int i=0;i<ss;i++){
                                filein.read(in);
                                scalerdata[i].count(bbtoint(in));
                            }
                            filein.read(in);
                        }else{
                            filein.read(in);
                            ss = bbtoint(in);
                            for(int i=0;i<ss;i++){
                                filein.read(inn);
                                scalerdata[i].count(bbbbtoint(inn));
                            }
                            filein.read(in);
                        }
                        filein.read(in);
                    }
                }
            }
            filein.close();
        }catch(IOException e){
            System.out.println("File Read Error!!");
        }
        return counter;
    }

    /* Read data from File */
    long fileRead(String path){
        FileInputStream filein;
        int n,tmp,buffsize;
        boolean sc = false;
        byte[] in,inn,buffdata;
        long counter;
        int index;
        index = 0;
        counter = 0;
        n = 0;
        in = new byte[2];
        inn = new byte[4];
        try{
            filein = new FileInputStream(path);
            filein.read(in);
            while(true){
                index = 0;
                n = 0;
                if(bbtoint(in) == 0x0000){
                    filein.read(in);
                    filein.read(in);
                    buffsize = bbtoint(in);
                    logbyte = new byte[61442];
                    filein.read(logbyte,0,buffsize*2+2);
                    while(btos(index) == 0xcc77){
                        counter++;
                        index += 4;
                        for(n=0;n<dataNum;n++){
                            inputdata[n] = btos(index);
                            index += 2;
                        }
                        countInputData(n);
                    }
                    filein.read(in);
                    if(bbtoint(in) == 0xaaaa || bbtoint(in) == 0xbbbb){
                        int ss;
                        sc = true;
                        if(bbtoint(in) == 0xaaaa){
                            filein.read(in);
                            ss = bbtoint(in);;
                            for(int i=0;i<ss;i++){
                                filein.read(in);
                                scalerdata[i].count(bbtoint(in));
                            }
                            filein.read(in);
                        }else{
                            filein.read(in);
                            ss = bbtoint(in);
                            for(int i=0;i<ss;i++){
                                filein.read(inn);
                                scalerdata[i].count(bbbbtoint(inn));
                            }
                            filein.read(in);
                        }
                        filein.read(in);
                    }
                    if(bbtoint(in) != 0x0000){
                        break;
                    }
                }
            }
            filein.close();
        }catch(IOException e){
            System.out.println("File Read Error!!");
        }
        return counter;
    }

    /* Thread run */
    public void run(){
        int readcnt;
        readcnt = 0;
        while(true){
            try{
                socket.receive(packet);
                /* System.out.println("Received"); */
                eventCounter += dataShape();
                scalerFrame.updateScaler();
                repaintGraph();
            }catch(IOException e){
                break;
            }
            
            try{
                Thread.currentThread().sleep(10);
            }catch(InterruptedException e){}
            
        }
    }

    public void repaintGraph(){
        for(int i=0;i<histNum;i++){
            if(histFrame[i].isShowing() == true){
                histcanvas[i].repaint();
            }
        }
        for(int i=0;i<dimNum;i++){
            if(twodimFrame[i].isShowing() == true){
                twodimFrame[i].repaintcanvas();
            }
        }
        if(runButton.getLabel() != "Stop"){
			for(int i=0;i<threeDimNum;i++){
				if(threedim[i].isShowing() == true){
					threedim[i].repaintcanvas();
				}
			}
		}

        eventLabel.setText(Long.toString(eventCounter));
    }

	/* ------------- ActionListener ------------- */

    public void actionPerformed(ActionEvent evt){
        Object obj = evt.getSource();
        if(obj == scalerItem){
            scalerFrame.show();
        }
        if(obj == helpItem){
            HelpDialog di = new HelpDialog(this);
            di.show();
            /* new HelpWindow(this); */
        }
        if(obj == makeGateItem){
            new MakeGate(gateNum);
        }
        if(obj == gatedHistItem){
            new MakeGatedHist(histNum);
        }
        if(obj == runButton){
            if(runButton.getLabel() == "Run"){
                try{
                    logbyte = new byte[61442];
                    packet = new DatagramPacket(logbyte,61442);
                    socket = new DatagramSocket(13948);
                }catch(SocketException e){
                    System.out.println("Socket Exception");
                }
                
                runDate = new Date();
                if(saveFlag == true){
                    startDate = runDate;
                    runTime = 0;
                    suspendTime = 0;
                }else{
                    suspendTime += runDate.getTime() - stopDate.getTime();
                }
                startLabel.setText("Start : "+dateformat.format(runDate));
                
                readThread = new Thread(this);
                readThread.start();
                runButton.setLabel("Stop");
                setEnabledItems(false);
                saveFlag = false;
            }else{
                socket.close();

                stopDate = new Date();
                stopLabel.setText("Stop : "+dateformat.format(stopDate));
                runTime += stopDate.getTime() - runDate.getTime();

                runButton.setLabel("Run");
                repaintGraph();
                setEnabledItems(true);
                //counterRead();
            }
        }
        for(int i=0;i<histNum;i++){
            if(obj == histItem[i]){
                histFrame[i].show();
            }
        }
        for(int i=0;i<threeDimNum;i++){
            if(obj == threeDimItem[i]){
				if(dimNum > 0){
	                threedim[i].show();
	            }else{
					System.out.println("No Data\nPlease make 2D Data.");
				}
            }
        }
        for(int i=0;i<dimNum;i++){
            if(obj == dimItem[i]){
                twodimFrame[i].show();
            }
        }
		if(obj == quitItem){
            if(runButton.getLabel() == "Run"){
                systemExit();
            }else{
                System.out.println("Please push Stop Button!!");
            }
		}if(obj == clearItem){
        clearData();
        repaintGraph();
    }if(obj == saveItem){
    }if(obj == clearGraphItem){
        boolean an = showDialog("You want to clear Graph ?");
        if(an == true){
            clearGraph();
            repaintGraph();
        }
    }
        for(int i=0;i<histNum;i++){
            if(obj == saveHistItem[i]){
                saveDialog.setFile(runName+"_"+Integer.toString(runcounter)+"_"+histdata[i].getName()+".hist");
                saveDialog.show();
                if(saveDialog.getFile() != null){
                    saveHistogram(saveDialog.getDirectory() + saveDialog.getFile(),i);
                }
            }
        }
        for(int i=0;i<dimNum;i++){
            if(obj == saveDimItem[i]){
                saveDialog.setFile(runName+"_"+Integer.toString(runcounter)+"_"+dimdata[i].getName()+".2d");
                saveDialog.show();
                if(saveDialog.getFile() != null){
                    saveTwodim(saveDialog.getDirectory() + saveDialog.getFile(),i);
                }
            }
        }
        if(obj == openItem || obj == addOpenItem){
            openDialog.show();
            if(openDialog.getFile() != null){
				if(obj == openItem){
                	for(int i=0;i<histNum;i++){
                    	histdata[i].clear();
                	}
                	for(int i=0;i<dimNum;i++){
                    	dimdata[i].clear();
                	}
                }
                /*repaintGraph();*/
                setEnabledItems(true);
                this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                eventCounter = fileRead(openDialog.getDirectory() + openDialog.getFile());
                runButton.setEnabled(false);
                saveFlag = true;
                scalerFrame.updateScaler();
                repaintGraph();
                this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
        }
        if(obj == safeOpenItem){
            openDialog.show();
            if(openDialog.getFile() != null){

                for(int i=0;i<histNum;i++){
                    histdata[i].clear();
                }
                for(int i=0;i<dimNum;i++){
                    dimdata[i].clear();
                }
                /*repaintGraph();*/
                setEnabledItems(true);
                this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                eventCounter = safeFileRead(openDialog.getDirectory() + openDialog.getFile());
                runButton.setEnabled(false);
                saveFlag = true;
                scalerFrame.updateScaler();
                repaintGraph();
                this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
        }
        if(obj == oldopenItem){
            int low,high,flag;
            FileInputStream filein;
            openDialog.show();
            if(openDialog.getFile() != null){
                for(int i=0;i<histNum;i++){
                    histdata[i].clear();
                }
                for(int i=0;i<dimNum;i++){
                    dimdata[i].clear();
                }
                setEnabledItems(true);
                try{
                    filein = new FileInputStream(openDialog.getDirectory() + openDialog.getFile());
                    eventCounter = 0;
                    this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                    while((flag = filein.read()) != -1){
                        int n,kind,kk,check;
                        n=0;
                        check = flag;
                        boolean dataflag = true;
                        flag = filein.read();;
                        check = (check | flag<<8) & 0xffff;
                        if(check == 0xffff){
                            eventCounter++;
                            while(n < dataNum){
                                kk = filein.read();
                                kind = kk & 0x0f;
                                if(kind == 0x01){
                                    low = filein.read();
                                    low = low & 0x00ff;
                                    high = filein.read();
                                    high = high & 0x00ff;
                                    high = high<<8 & 0xff00;
                                    inputdata[n] = low | high;
                                    n++;
                                }else{
                                    n++;
                                    dataflag = false;
                                }
                            }
                        }
                        if(dataflag == true){
                            n = countInputData(n);
                        }
                    }

                }catch(IOException e){
                    System.err.println("Caught open IOException");
                    //System.exit(1);
                }
                runButton.setEnabled(false);
                saveFlag = true;
                repaintGraph();
                this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
        }

        /* Print Graphics */
        for(int i=0;i<histNum;i++){
            if(obj == printHistItem[i]){
                printGraphics(histFrame[i]);
            }
        }
        for(int i=0;i<dimNum;i++){
            if(obj == printDimItem[i]){
                printGraphics(twodimFrame[i]);
            }
        }
		for(int i=0;i<threeDimNum;i++){
            if(obj == printThreeDimItem[i]){
                printGraphics(threedim[i]);
            }
        }
        if(obj == makeDimItem){
            MakeTwodim maketwodim = new MakeTwodim();
        }
	}
    /* End of ActionListener */

    /* ----------- Utility ------------- */

    /* Show AlertDialog */
    boolean showDialog(String mes){
        boolean ans;
        ans = false;
        if(alertflag == false){
            alertflag = true;
            alertdi = new AlertDialog();
            ans = alertdi.showDialog(mes);
        }
        return ans;
    }

    /* net changed */
    /* System Exit */
    public void systemExit(){
		System.exit(0);
    }

    /* Make 2D Graph */
    public void make2D(int x,int y,int size,int sc,String name,int interval){
        int xscale,yscale;
        if(x < dataNum){
            xscale = histdata[x].getScale();
        }else{
            xscale = histdata[gate[x-dataNum].value].getScale();
        }
        if(y < dataNum){
            yscale = histdata[y].getScale();
        }else{
            yscale = histdata[gate[y-dataNum].value].getScale();
        }

        dimdata[dimNum] = new DimData(dimNum,xscale,yscale,size,sc,name);
        dimpoint[dimNum] = new Point(x,y);
        twodimFrame[dimNum] = new Twodim(dimNum,interval,size);
        dimItem[dimNum] = new MenuItem(name);
        dimItem[dimNum].addActionListener(this);
        printDimItem[dimNum] = new MenuItem(name);
        printDimItem[dimNum].addActionListener(this);
        saveDimItem[dimNum] = new MenuItem(name);
        saveDimItem[dimNum].addActionListener(this);
        dimSubMenu.add(dimItem[dimNum]);
        saveDimSubMenu.add(saveDimItem[dimNum]);
        printDimSubMenu.add(printDimItem[dimNum]);
        dimNum++;
        for(int i=0;i<threeDimNum;i++){
	  threedim[i].updateStatus();
	}
    } 

    /* Add Gate Data */
    public void addGate(String na,int t,int n,int v,int l,int h){
        gate[gateNum] = new GateData(na,t,n,v,l,h);
        gateNum++;
    }

    /* Add Gated Histogram */
    public void addGatedHist(String n,int g,int s){
        int a = dataNum + g;
        histdata[histNum] = new HistData(n,a,s);
        histcanvas[histNum] = new HistCanvas(histNum);
        histFrame[histNum] = new Histogram(histNum);
        paramhist[histNum] = new ParamHist(histNum);
        histItem[histNum] = new MenuItem(n);
        histItem[histNum].addActionListener(this);
        saveHistItem[histNum] = new MenuItem(n);
        saveHistItem[histNum].addActionListener(this);
        printHistItem[histNum] = new MenuItem(n);
        printHistItem[histNum].addActionListener(this);
        histSubMenu.add(histItem[histNum]);
        saveHistSubMenu.add(saveHistItem[histNum]);
        printHistSubMenu.add(printHistItem[histNum]);
        histNum++;
    }

    /* Set Enabled Items */
    void setEnabledItems(boolean boo){
        saveItem.setEnabled(boo);
        saveHistSubMenu.setEnabled(boo);
        saveDimSubMenu.setEnabled(boo);
        clearItem.setEnabled(boo);
        openItem.setEnabled(boo);
        safeOpenItem.setEnabled(boo);
        oldopenItem.setEnabled(boo);
    }

    /* ItemListener */
    public void itemStateChanged(ItemEvent evt){
        //int time;
        //String select;
        //select = sleepChoice.getSelectedItem();
        //time = (Integer.decode(select)).intValue();
        //sleepTime = time;
    }


    /* Clear Scaler */
    void clearScaler(){
        for(int i=0;i<StartupDAQ.scalerSum;i++){
            scalerdata[i].clear();
        }
        scalerFrame.updateScaler();
    }

    /* Clear Graph */
    void clearGraph(){
        for(int i=0;i<histNum;i++){
            histdata[i].clear();
        }
        for(int i=0;i<histNum;i++){
            histcanvas[i].repaint();
        }
        for(int i=0;i<dimNum;i++){
            dimdata[i].clear();
            twodimFrame[i].setClearFlag();
            twodimFrame[i].repaintcanvas();
        }
    }

    /* Clear Data */
    void clearData(){
        eventCounter = 0;
        clearGraph();
        clearScaler();
        if(logboolean == true){
            try{
                writelog.close();
                logboolean = false;
            }catch(IOException e){
                System.err.println("Caught IOException");
            }
        }
        saveItem.setEnabled(false);
        saveHistSubMenu.setEnabled(false);
        saveDimSubMenu.setEnabled(false);
        clearItem.setEnabled(false);
        runButton.setEnabled(true);
        eventLabel.setText("0");
    }

    /* Save Histogram Data */
    void saveHistogram(String path,int num){
        String stdata;
        FileWriter saveWriter;
        BufferedWriter buffWriter;

        try{
            saveWriter = new FileWriter(path);
            buffWriter = new BufferedWriter(saveWriter);
            for(int i=0;i<histdata[num].getScale();i++){
                stdata = Integer.toString(histdata[num].getData(i));
                buffWriter.write(stdata,0,stdata.length());
                buffWriter.newLine();
            }
            buffWriter.close();
            saveWriter.close();
        }catch(IOException e){
            System.out.println("Cought list IOException");
        }
    }

    void saveTwodim(String path,int num){
        String stdata;
        int si;
        FileWriter saveWriter;
        BufferedWriter buffWriter;
        si = dimdata[num].getSize();
        this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try{
            saveWriter = new FileWriter(path);
            buffWriter = new BufferedWriter(saveWriter);
            for(int i=0;i<si;i++){
                for(int j=0;j<si;j++){
                    stdata = Integer.toString(dimdata[num].read(j,i));
                    buffWriter.write(stdata,0,stdata.length());
                    buffWriter.newLine();
                }
                buffWriter.newLine();
            }
            buffWriter.close();
            saveWriter.close();
        }catch(IOException e){
            System.out.println("Cought list IOException");
        }
        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }

    /* 2bytes to short */
    int btos(int ind){
        int a;
        a = (logbyte[ind]&0x000000ff)|((logbyte[ind+1]<<8) & 0x0000ff00);
        return a;
    }

    /* 4bytes to int */
    int btoi(int ind){
        int a;
        a = (logbyte[ind]&0x000000ff)|((logbyte[ind+1]<<8) & 0x0000ff00)|
            ((logbyte[ind+2]<<16) & 0x00ff0000);
        return a;
    }

    int countInputData(int n){
        for(int i=0;i<gateNum;i++){
            switch(gate[i].type){
            case 0:
                if(gate[i].check(inputdata[gate[i].num]) == true){
                    inputdata[dataNum+i] = inputdata[gate[i].value];
                }else{
                    inputdata[dataNum+i] = 0xffffffff;
                }
                n++;
                break;
            case 1:
                if(gate[i].check(gate[gate[i].gate1].flag,gate[gate[i].gate2].flag) == true){
                    inputdata[dataNum+i] = inputdata[gate[i].value];
                }else{
                    inputdata[dataNum+i] = 0xffffffff;
                }
                n++;
                break;
            }
        }
        for(int i=0;i<histNum;i++){
            histdata[i].count(inputdata[histdata[i].dataNumber]);
        }
        for(int i=0;i<dimNum;i++){
            dimdata[i].count(inputdata[dimpoint[i].x],inputdata[dimpoint[i].y]);
        }
        return n;
    }

    /* dataShape */
    int dataShape(){
        int index,counter,n;
        index = 0;
        counter = 0;
        n = 0;
        if(btos(index) == 0x0000){
            index += 2;
            index += 2;
            /*counter = btos(index);*/
            index += 2;
            while(btos(index) == 0xcc77){
                counter++;
                index += 4;
                for(n=0;n<dataNum;n++){
                    inputdata[n] = btos(index);
                    index += 2;
                }
                n = countInputData(n);
            }
            index+=2;
            if(btos(index) == 0xaaaa || btos(index) == 0xbbbb){
                int ss;
                if(btos(index) == 0xaaaa){
                    index+=2;
                    ss = btos(index);
                    index+=2;
                    for(int i=0;i<ss;i++){
                        scalerdata[i].count(btos(index));
                        index+=2;
                    }
                    index+=2;
                }else{
                    index+=2;
                    ss = btos(index);
                    index+=2;
                    for(int i=0;i<ss;i++){
                        scalerdata[i].count(btoi(index));
                        index+=4;
                    }
                    index+=2;
                }
            }
        }
        return counter;
    }


	public void windowClosed(WindowEvent evt){
	}

	public void windowClosing(WindowEvent evt){
        if(runButton.getLabel() == "Run"){
            /* net changed */
            systemExit();
        }else{
            System.out.println("Please push Stop Button!!");
        }
	}

	public void windowOpened(WindowEvent evt){
	}

	public void windowIconified(WindowEvent evt){
	}

	public void windowDeiconified(WindowEvent evt){
	}

	public void windowActivated(WindowEvent evt){
	}

	public void windowDeactivated(WindowEvent evt){
	}
}
