import java.awt.*;
import java.awt.event.*;

public class ParamHist extends Frame
		implements WindowListener,ActionListener,ItemListener{
    private int chbottom,chwide,cntbottom,cntsize,chpoint;
    private int paintswith = 0;
    private int[] curtop,curbottom;
    Panel paramPanel;
    TextField chbottomTF,cntbottomTF;
    Choice chchoice,cntchoice;
    Label chLabel,cntLabel,bottomLabel,wideLabel,spaceLabel;
    Label[] nameLabel,numberLabel;
    Checkbox curCheckbox0,curCheckbox1;
    TextField[] curTF;
    private int paramNumber;

    public ParamHist(int num){
        paramNumber = num;

	//this.setSize(200,160);
	this.setFont(StartupDAQ.defaultFont);
        this.setTitle("Parameter "+StartupDAQ.conFrame.histdata[paramNumber].getName());

        chbottom = 0;
        chwide = StartupDAQ.conFrame.histdata[paramNumber].getScale();
        cntbottom = 0;
        cntsize = 1;

	addWindowListener(this);

	paramPanel = new Panel();
	paramPanel.setLayout(new GridLayout(0,3));

        /* Cursor */
        curtop = new int[2];
        curbottom = new int[2];
        curtop[0] = StartupDAQ.conFrame.histdata[paramNumber].getScale() - 1;
        curbottom[0] = 0;
        curCheckbox0 = new Checkbox("Cursor",false);
        curCheckbox1 = new Checkbox("Cursor(b)",false);
        curTF = new TextField[4];
        for(int i=0;i<4;i++){
            curTF[i] = new TextField();
        }
        curTF[0].setText(Integer.toString(curtop[0]));
        curTF[1].setText(Integer.toString(curbottom[0]));
        nameLabel = new Label[3];
        numberLabel = new Label[3];
        nameLabel[0] = new Label("Sum",Label.CENTER);
        nameLabel[1] = new Label("Centroid",Label.CENTER);
        nameLabel[2] = new Label("FWHM",Label.CENTER);
        for(int i=0;i<3;i++){
            numberLabel[i] = new Label("",Label.CENTER);
        }

	/* GUI */
	chbottomTF = new TextField("0");
	cntbottomTF = new TextField("0");
	chLabel = new Label("Channel",Label.CENTER);
	cntLabel = new Label("Count",Label.CENTER);
	spaceLabel = new Label("");
	bottomLabel = new Label("base",Label.CENTER);
	wideLabel = new Label("width",Label.CENTER);

	/* Choice */
	chchoice = new Choice();
	cntchoice = new Choice();
	for(int i=StartupDAQ.conFrame.histdata[paramNumber].getScale();i>16;i/=2){
	    chchoice.addItem(Integer.toString(i));
	}
	for(int i=256;i<10000;i*=2){
	    cntchoice.addItem(Integer.toString(i));
	}

	/* addActionListener */
	chbottomTF.addActionListener(this);
	cntbottomTF.addActionListener(this);
        curTF[0].addActionListener(this);
        curTF[1].addActionListener(this);

	/* addItemListener */
	chchoice.addItemListener(this);
	cntchoice.addItemListener(this);
        curCheckbox0.addItemListener(this);

        /* add GUIs*/
	paramPanel.add(spaceLabel);
	paramPanel.add(bottomLabel);
	paramPanel.add(wideLabel);
	paramPanel.add(chLabel);
	paramPanel.add(chbottomTF);
	paramPanel.add(chchoice);
	paramPanel.add(cntLabel);
	paramPanel.add(cntbottomTF);
	paramPanel.add(cntchoice);
        paramPanel.add(curCheckbox0);
        paramPanel.add(curTF[1]);
        paramPanel.add(curTF[0]);
        for(int i=0;i<3;i++){
            paramPanel.add(nameLabel[i]);
        }
        for(int i=0;i<3;i++){
            paramPanel.add(numberLabel[i]);
        }
		this.add("Center",paramPanel);
        this.pack();
	}

    public void setchChoice(){
	chbottomTF.setText(Integer.toString(chbottom));
        if(chwide > 16){
            chchoice.select(Integer.toString(chwide));
        }else{
            chchoice.select("32");
        }
    }

    public void setcntChoice(){
        cntbottomTF.setText(Integer.toString(cntbottom));
        if(cntsize*256 < 10000){
            cntchoice.select(Integer.toString(cntsize*256));
        }else{
            cntchoice.select("8192");
        }
    }

    /* Check TextFields */
    public boolean checkHist(String chString){
	int j=0;
	for(int i=0;i<chString.length();i++){
	    if(Character.isDigit(chString.charAt(i)) == false){
		j++;
	    }
	}
	if(j == 0){
	    return true;
	}else{
	    return false;
	}
    }

    /* ParamHist ActionListener */
    public void actionPerformed(ActionEvent evt){
	Object obj = evt.getSource();
	
	if(obj == chbottomTF){
	    int chbottom;
	    String chString = chbottomTF.getText();
	    if(checkHist(chString) == true){
		chbottom = (Integer.decode(chString)).intValue();
		setchbottom(chbottom);
		StartupDAQ.conFrame.histcanvas[paramNumber].repaint();
	    }else{
		System.out.print("Channel Error!!");
	    }
	    StartupDAQ.conFrame.histFrame[paramNumber].repaint();
	}
	if(obj == cntbottomTF){
	    int cntbottom;
	    String chString = cntbottomTF.getText();
	    if(checkHist(chString) == true){
		cntbottom = (Integer.decode(chString)).intValue();
		setcntbottom(cntbottom);
		StartupDAQ.conFrame.histcanvas[paramNumber].repaint();
	    }else{
		System.out.print("Channel Error!!");
	    }
	    StartupDAQ.conFrame.histFrame[paramNumber].repaint();
	}
        if(obj == curTF[0]){
            String curString = curTF[0].getText();
            if(checkHist(curString) == true){
                curtop[0] = (Integer.decode(curString)).intValue();
                StartupDAQ.conFrame.histcanvas[paramNumber].repaint();
            }else{
                System.out.print("Cursol Error!!");
            }
        }
        if(obj == curTF[1]){
            String curString = curTF[1].getText();
            if(checkHist(curString) == true){
                curbottom[0] = (Integer.decode(curString)).intValue();
                StartupDAQ.conFrame.histcanvas[paramNumber].repaint();
            }else{
                System.out.print("Cursol Error!!");
            }
        }
    }
    
    /* Param ItemListener */
    public void itemStateChanged(ItemEvent evt){
	Object obj = evt.getSource();
	String selecteditem;
	int wide,size;
	
	if(obj == chchoice){
	    selecteditem = chchoice.getSelectedItem();
	    wide = (Integer.decode(selecteditem)).intValue();
	    setchwide(wide);
	    chbottomTF.setText(Integer.toString(chbottom));
	    StartupDAQ.conFrame.histFrame[paramNumber].repaint();
            StartupDAQ.conFrame.histcanvas[paramNumber].repaint();
	}
	if(obj == cntchoice){
	    selecteditem = cntchoice.getSelectedItem();
	    size = (Integer.decode(selecteditem)).intValue() / 256;
	    setcntsize(size);
	    cntbottomTF.setText(Integer.toString(cntbottom));
	    StartupDAQ.conFrame.histFrame[paramNumber].repaint();
            StartupDAQ.conFrame.histcanvas[paramNumber].repaint();
	}
        if(obj == curCheckbox0){
            StartupDAQ.conFrame.histcanvas[paramNumber].repaint();
        }
    }





/* ------------------- Parameter Faunctions --------------------*/

    
    /* set parameters */
    public void setchbottom(int cb){
	if(cb < 0){
	    cb = 0;
	}else if(cb + chwide >= StartupDAQ.conFrame.histdata[paramNumber].getScale()){
            chbottom = StartupDAQ.conFrame.histdata[paramNumber].getScale() - chwide;
	}else{
	    chbottom = cb;
	}
    }
    public void setcntbottom(int cb){
	if(cb < 0){
	    cntbottom = 0;
	}else{
	    cntbottom = cb;
	}
    }
    
    public void setchwide(int wide){
	int cb;
        if(wide == StartupDAQ.conFrame.histdata[paramNumber].getScale()){
            chbottom =0;
            chwide =StartupDAQ.conFrame.histdata[paramNumber].getScale();
        }else if(chwide != wide){
	    cb = (chbottom + chwide/2) - wide/2;
	    chwide = wide;
	    setchbottom(cb);
	}else{
	}
    }
    
    public void upchwide(){
	chwide *= 2;
	if(chwide > StartupDAQ.conFrame.histdata[paramNumber].getScale()){
	    chwide = StartupDAQ.conFrame.histdata[paramNumber].getScale();
	}
    }
    
    public void downchwide(){
	chwide /= 2;
	if(chwide == 0){
	    chwide = 1;
	}
    }
    
    public void setcntsize(int size){
	cntsize = size;
	setcntbottom(cntbottom);
    }

    public void upcntsize(){
	cntsize *= 2;
    }
    
    public void downcntsize(){
	cntsize /= 2;
	if(cntsize == 0){
	    cntsize = 1;
	}		
    }
    
    public void setchpoint(int xx){
        int ch;
        if(chwide <= 512){
            ch = xx/(512/chwide);
            chpoint = ch + chbottom;
        }else{
            ch = (chwide/512)*xx;
            chpoint = ch + chbottom;
        }
	paintswith = 1;
    }
    
    public void setpaintswith(int pw){
	paintswith = pw;
    }
    
    
    /* get parameters */
    public int getchbottom(){
	return chbottom;
    }
    
    public int getcntbottom(){
	return cntbottom;
    }
    
    public int getcntsize(){
	return cntsize;
    }
    
    public int getchwide(){
	return chwide;
    }
    
    public int getcntwide(){
	int cntwide = 256 * cntsize;
	return cntwide;
    }
    
    public int getchpoint(){
	return chpoint;
    }
    
    public int getpaintswith(){
	return paintswith;
    }
    

/* ---------------------------------------------------------- */

    /* Cursol Functions */
    public void setcur(String set,int i,int ch){
        if(ch < 0)
            ch = 0;
        if(ch > StartupDAQ.conFrame.histdata[paramNumber].getScale() - 1)
            ch = StartupDAQ.conFrame.histdata[paramNumber].getScale() -1;
        if(i < 0)
            i = 0;
        if(i > 1)
            i = 1;
        if(set == "top"){
            curtop[i] = ch;
            curTF[0].setText(Integer.toString(ch));
        }else{
            curbottom[i] = ch;
            curTF[1].setText(Integer.toString(ch));
        }
    }

    public int getcur(String set,int i){
        if(i < 0)
            i = 0;
        if(i > 1)
            i = 1;
        if(set == "top"){
            return curtop[i];
        }else{
            return curbottom[i];
        }
    }


    public int getPoint(int xx){
        int ch;
        if(xx < 0){
            xx = 0;
        }
        if(xx > 511){
            xx = 511;
        }
        if(chwide <= 512){
            ch = (int)(xx/(512/chwide));
            ch += chbottom;
        }else{
            ch = (chwide/512)*xx;
            ch += chbottom;
        }
	return ch;
    }


    /* Calc Sum,Centroid,Sigma */
    public void curCountSum(){
        int sum=0,x,bottom,top;
        float centroid=0,sigma=0,fwhm=0;
        if(curtop[0] > curbottom[0]){
            top = curtop[0];
            bottom = curbottom[0];
        }else{
            top = curbottom[0];
            bottom = curtop[0];
        }
        for(int i=bottom;i<=top;i++){
            x = StartupDAQ.conFrame.histdata[paramNumber].getData(i);
            sum += x;
            centroid += x*i;
            sigma += x*i*i;
        }
        centroid /= (double)sum;
        sigma = sigma/(float)sum - (centroid * centroid);
        fwhm = (float)(java.lang.Math.sqrt((double)sigma)*2.35);
        numberLabel[0].setText(Integer.toString(sum));
        numberLabel[1].setText(Float.toString(centroid));
        numberLabel[2].setText(Float.toString(fwhm));
    }
/* ----------------------------------------------------------- */

    /* WindowListener */
    
    public void windowClosed(WindowEvent evt){
    }

    public void windowClosing(WindowEvent evt){
	dispose();
    }

    public void windowOpened(WindowEvent evt){
    }

    public void windowIconified(WindowEvent evt){
    }

    public void windowDeiconified(WindowEvent evt){
    }

    public void windowActivated(WindowEvent evt){
    }

    public void windowDeactivated(WindowEvent evt){
    }
}
