import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class StartupDAQ extends Frame
		implements ActionListener,WindowListener{
    TextField runnameTF;
    Button submitButton,cancelButton;
    Panel startupPanel;
    Label runnameLabel;
    public static String[] dataNameST,scalerName;
    public static int scalerSum=0,tdSum=0;
    public static int[] dataBit,tdSize;
    Label[] dataNameLabel,dataBitLabel;
    public static NControlDAQ conFrame;
    public static Font defaultFont;
    int funcsum=0;
    Point dim[];
    String dimname[];
    int dimsize[],dimnum;
    String userDir,setupFile;

	public static void main(String argv[]){
        StartupDAQ startup = new StartupDAQ();
        startup.setVisible(true);
	}

    public StartupDAQ(){
        Date date;
        SimpleDateFormat sdf;
        this.setTitle("Startup Window");
        //this.setSize(150,190);
        defaultFont = new Font("Dialog",Font.PLAIN,10);
        this.setFont(defaultFont);

        addWindowListener(this);
        startupPanel = new Panel();
        startupPanel.setLayout(new GridLayout(0,2));

        scalerName = new String[50];
        dimname = new String[50];
        dimsize = new int[50];
        dim = new Point[50];

        date = new Date();
        sdf = new SimpleDateFormat("MMMdd",Locale.US);

        dimnum = 0;
        readDataTable();
        readScalerTable();
        read2DTable();

        runnameTF = new TextField(sdf.format(date));
        submitButton = new Button("OK");
        cancelButton = new Button("Cancel");
        runnameLabel = new Label("Run name",Label.CENTER);

        /* addActionListener */
        runnameTF.addActionListener(this);
        submitButton.addActionListener(this);
        cancelButton.addActionListener(this);

        startupPanel.add(runnameLabel);
        startupPanel.add(runnameTF);
        startupPanel.add(new Label("--------",Label.CENTER));
        startupPanel.add(new Label("--------",Label.CENTER));
        startupPanel.add(new Label("Data Neme",Label.CENTER));
        startupPanel.add(new Label("Data Bit Size",Label.CENTER));
        for(int i=0;i<funcsum;i++){
            startupPanel.add(dataNameLabel[i]);
            startupPanel.add(dataBitLabel[i]);
        }
        startupPanel.add(submitButton);
        startupPanel.add(cancelButton);
        this.add(startupPanel,"North");
        this.pack();
    }

	/* ParamHist ActionListener */
	public void actionPerformed(ActionEvent evt){
      Object obj = evt.getSource();
      if(obj == submitButton || obj == runnameTF){
          String datanumString;
          NControlDAQ.dimNum = 0;

          NControlDAQ.runName = runnameTF.getText();
          this.setVisible(false);
          conFrame = new NControlDAQ();
          //conFrame.setVisible(true);
          for(int i=0;i<this.dimnum;i++){
              conFrame.make2D(dim[i].x,dim[i].y,dimsize[i],0,dimname[i],0); 
          }
      }
      if(obj == cancelButton){
          System.out.println("Bye!!");
          System.exit(0);
      }
    }

    /* Read datatable.txt */
    public void readDataTable(){
        File readFile = new File("datatable.txt");
        byte[] readData;
        String readST="no";
        StringTokenizer stToken;
        try{
            FileInputStream fileIn = new FileInputStream(readFile);
            int fileSize = fileIn.available();
            readData = new byte[fileSize];
            fileIn.read(readData);
            fileIn.close();
            readST = new String(readData);
        }catch(IOException e){
            String mes;
            mes = "Error !!\n(1) Error in SetupFile\n(2) Misstyped SetupFile name or path\n(3) Can't open datatable.txt";
            System.out.println(mes);
            System.exit(0);
        }
        stToken = new StringTokenizer(readST);
        int index=0,a;
        /*
        while((a = readST.indexOf(" ",index)) != -1){
            funcsum++;
            index = a+1;
        }
        dataNameST = new String[funcsum];
        dataBit = new int[funcsum];
        NControlDAQ.dataNum = funcsum;
        */
        dataNameST = new String[50];
        dataBit = new int[50];
        
        int j = 0;
        String tmp,dd="2D";
        while(stToken.hasMoreTokens() == true){
            tmp = stToken.nextToken();
            if(tmp.equals(dd) == false){
                dataNameST[j] = tmp;
                dataBit[j] = Integer.parseInt(stToken.nextToken());
                if(dataBit[j] > 16){
                    dataBit[j] = 16;
                }
                j++;
            }
        }
        funcsum = j;
        NControlDAQ.dataNum = funcsum;
        dataNameLabel = new Label[funcsum];
        dataBitLabel = new Label[funcsum];
        for(int i=0;i<funcsum;i++){
            dataNameLabel[i] = new Label(dataNameST[i],Label.CENTER);
            dataBitLabel[i] = new Label(Integer.toString(dataBit[i]),Label.CENTER);
        }
    }
    public void readScalerTable(){
        File readFile = new File("scalertable.txt");
        byte[] readData;
        String readST="no";
        StringTokenizer stToken;
        if(readFile.exists() == true){
            try{
                FileInputStream fileIn = new FileInputStream(readFile);
                int fileSize = fileIn.available();
                readData = new byte[fileSize];
                fileIn.read(readData);
                fileIn.close();
                readST = new String(readData);
            }catch(IOException e){
                System.exit(0);
            }
            stToken = new StringTokenizer(readST);
            while(stToken.hasMoreTokens() == true){
                scalerName[scalerSum] = stToken.nextToken();
                scalerSum++;
            }
        }
    }

    public void read2DTable(){
        File readFile = new File("2dtable.txt");
        byte[] readData;
        String readST="no";
        StringTokenizer stToken;
        if(readFile.exists() == true){
            try{
                FileInputStream fileIn = new FileInputStream(readFile);
                int fileSize = fileIn.available();
                readData = new byte[fileSize];
                fileIn.read(readData);
                fileIn.close();
                readST = new String(readData);
            }catch(IOException e){
                System.exit(0);
            }
            stToken = new StringTokenizer(readST);
            while(stToken.hasMoreTokens() == true){
                dim[dimnum] = new Point();
                dim[dimnum].x = Integer.parseInt(stToken.nextToken());
                dim[dimnum].y = Integer.parseInt(stToken.nextToken());
                dimsize[dimnum] = Integer.parseInt(stToken.nextToken());
                dimname[dimnum] = dataNameST[dim[dimnum].x]+"-"+dataNameST[dim[dimnum].y];
                dimnum++;
            }
        }
    }

	/* WindowListener */

	public void windowClosed(WindowEvent evt){
		System.exit(0);
	}

	public void windowClosing(WindowEvent evt){
		dispose();
	}

	public void windowOpened(WindowEvent evt){
	}

	public void windowIconified(WindowEvent evt){
	}

	public void windowDeiconified(WindowEvent evt){
	}

	public void windowActivated(WindowEvent evt){
	}

	public void windowDeactivated(WindowEvent evt){
	}
}
