import java.awt.*;
import java.awt.event.*;

public class Threedim extends Frame
	implements WindowListener,ItemListener,ActionListener{
	private ThreedimCanvas threedimcanvas;
    private int dimNumber;
	private int size,xshift,yshift,mag;
	private double theta,phi,costheta,sintheta,cosphi,sinphi;
	private Point point[],canvassize;
	private int dimdatanum,thetado,phido,interval,intervalcnt;
	private int oldDimSum = 0;
	private Graphics grf;
	private Image offs;

	Button tallButton,shortButton;
	Button[] togleButton,interButton;
	Choice dataChoice,lineChoice,plotChoice;

	int[] col = {0x000033,0x330066,0x000066,0x003366,0x330099,
		     0x000099,0x003399,0x3300cc,0x0000cc,0x0033cc,
		     0x0066cc,0x6600ff,0x3300ff,0x0000ff,0x0033ff,
		     0x6633ff,0x3333ff,0x3366ff,0x6666ff,0x0099ff,
		     0x3399ff,0x6699ff,0x00ccff,0x33ccff,0x66ccff,
		     0x99ccff,0xccccff,0x00ffff,0x33ffff,0x66ffff,
		     0x99ffff,0xccffff};


	public Threedim(int num){
	  canvassize = new Point(256,256);
	  this.setLayout(null);

	  /* Initialize */
	  size = 256;
	  thetado = 15;
	  phido = 15;
	  mag = 1;
	  interval = 5;
	  intervalcnt = 1;

	  togleButton = new Button[4];
	  for(int i=0;i<4;i++){
	    togleButton[i] = new Button("");
	    togleButton[i].addActionListener(this);
	  }
	  interButton = new Button[2];
	  for(int i=0;i<2;i++){
	    interButton[i] = new Button("");
	    interButton[i].setBackground(Color.blue);
	    interButton[i].addActionListener(this);
	  }

	  dataChoice = new Choice();
	  dataChoice.addItemListener(this);
	  lineChoice = new Choice();
	  lineChoice.add("Linear");
		lineChoice.add("Log");
		lineChoice.addItemListener(this);
		plotChoice = new Choice();
		plotChoice.add("Normal");
		plotChoice.add("Trans");
		plotChoice.addItemListener(this);

		tallButton = new Button("Tall");
		tallButton.addActionListener(this);
		shortButton = new Button("Short");
		shortButton.addActionListener(this);
		tallButton.setBounds(10,25,30,20);
		shortButton.setBounds(40,25,30,20);
		lineChoice.setBounds(75,25,60,20);
		plotChoice.setBounds(135,25,60,20);
		dataChoice.setBounds(195,25,100,20);

		togleButton[0].setBounds(298,30,8,8);
		togleButton[1].setBounds(315,30,8,8);
		togleButton[2].setBounds(307,25,8,8);
		togleButton[3].setBounds(307,36,8,8);

		interButton[0].setBounds(323,25,10,10);
		interButton[1].setBounds(323,35,10,10);

        this.setFont(StartupDAQ.defaultFont);
        this.setBackground(Color.lightGray);
		addWindowListener(this);

		point = new Point[4];
		dimdatanum = 0;

		threedimcanvas = new ThreedimCanvas();
		threedimcanvas.setBounds(20,20,canvassize.x,canvassize.y);
		this.setSize(canvassize.x+20,canvassize.y+50);
		this.add(threedimcanvas);
		this.add(tallButton);
		this.add(shortButton);
		this.add(lineChoice);
		this.add(plotChoice);
		this.add(dataChoice);
		for(int i=0;i<4;i++){
			this.add(togleButton[i]);
		}
		for(int i=0;i<2;i++){
			this.add(interButton[i]);
		}
	}

	void updateStatus(){
	  int newSum = StartupDAQ.conFrame.dimNum;
	  if(oldDimSum != newSum){
	    for(int i=oldDimSum;i<newSum;i++){
	      dataChoice.add(StartupDAQ.conFrame.dimdata[i].getName());
	    }
	    oldDimSum = newSum;
	  }
	}

	void calcParameters(int s,int t,int p){
	  size = s;
	  theta = Math.PI*t/180;
	  phi = Math.PI*p/180;
	  
	  costheta = Math.cos(theta);
	  sintheta = Math.sin(theta);
	  cosphi = Math.cos(phi);
	  sinphi = Math.sin(phi);

	  point[0] = new Point(0,(int)(size*sintheta));
	  point[1] = new Point((int)(size*costheta),0);
	  point[2] = new Point((int)(size*sinphi),point[0].y + (int)(size*cosphi));
	  point[3] = new Point(point[1].x + point[2].x,point[2].y - point[0].y);

	  canvassize.x = point[0].x;
	  canvassize.y = point[1].y;

	  for(int i=1;i<4;i++){
	    if(canvassize.x < point[i].x){
	      canvassize.x = point[i].x;
	    }
	    if(canvassize.y < point[i].y){
	      canvassize.y = point[i].y;
	    }
	  }
	  
	  if(phi < 0){
	    xshift = Math.abs(point[2].x) + 20;
	    canvassize.x += Math.abs(point[2].x);
	  }else{
	    xshift = 20;
	  }
	  if(theta < 0){
	    yshift = Math.abs(point[0].y) +30;
	    canvassize.y += Math.abs(point[0].y);
	  }else{
	    yshift = 30;
	  }

	  canvassize.x += 40;
	  canvassize.y += size/4;
	  if(canvassize.y > 718){
	    canvassize.y = 718;
	  }else if(canvassize.y < 448){
	    canvassize.y = 448;
	  }
	  int framex = canvassize.x + 20;
	  if(framex < 338){
	    framex = 338;
	  }
	  threedimcanvas.setBounds(10,50,canvassize.x,canvassize.y);
	  this.setTitle(StartupDAQ.conFrame.dimdata[dimdatanum].getName());
	  this.setSize(framex,canvassize.y+60);
	  offs = createImage(canvassize.x,canvassize.y);
	  grf = offs.getGraphics();
	  updateImage();
	}


    public void repaintcanvas(){
        updateImage();
        this.threedimcanvas.repaint();
    }

    public void paint(Graphics g){
      if(StartupDAQ.conFrame.dimdata[0] != null){
	updateStatus();
	calcParameters(StartupDAQ.conFrame.dimdata[dimdatanum].getSize(),thetado,phido);
      }
    }

	  int xdash(int x,int y){
		return (int)(x*costheta + y*sinphi);
	}

	int ydash(int x,int y){
		return (int)(y*cosphi + point[0].y - x*sintheta);
	}

	public void clearGraph(){
		threedimcanvas.repaint();
	}

	  class ThreedimCanvas extends Canvas implements MouseMotionListener{

	  public ThreedimCanvas(){
            setBackground(Color.white);
            addMouseMotionListener(this);
	  }

	  public void paint(Graphics g){
	    update(g);
	  }

	  public void update(Graphics g){
	    g.drawImage(offs,0,0,this);
	  }


        public void mouseDragged(MouseEvent e){
        }

        public void mouseMoved(MouseEvent e){
            //setPointLabel(e.getX(),size-e.getY());
        }
	}

	  void updateImage(){
	    grf.setColor(Color.white);
	    grf.fillRect(0,0,canvassize.x,canvassize.y);
	    grf.setColor(Color.black);
	    grf.drawLine(xshift+point[0].x,canvassize.y-yshift-point[0].y,xshift+point[1].x,canvassize.y-yshift-point[1].y);
	    grf.drawLine(xshift+point[1].x,canvassize.y-yshift-point[1].y,xshift+point[3].x,canvassize.y-yshift-point[3].y);
	    grf.drawLine(xshift+point[0].x,canvassize.y-yshift-point[0].y,xshift+point[2].x,canvassize.y-yshift-point[2].y);
	    grf.drawLine(xshift+point[2].x,canvassize.y-yshift-point[2].y,xshift+point[3].x,canvassize.y-yshift-point[3].y);

	    /* Label */
	    grf.drawString("0",xshift+point[0].x,canvassize.y-point[0].y-yshift+15);
	    if(phi < 0){
	      grf.drawString(Integer.toString(size),xshift+point[1].x,canvassize.y-point[1].y-yshift+15);
	      grf.drawString(Integer.toString(size),xshift+point[2].x-15,canvassize.y-point[2].y-yshift+15);
	      grf.drawString(Integer.toString(size*mag/2),xshift+point[2].x-15,canvassize.y-point[2].y-yshift-size/2);
	      grf.drawString(Integer.toString(size*mag/2),xshift+point[1].x+5,canvassize.y-point[1].y-yshift-size/2);
	      
	    }else{
	      grf.drawString(Integer.toString(size),xshift+point[1].x+10,canvassize.y-point[1].y-yshift+15);
	      grf.drawString(Integer.toString(size),xshift+point[3].x,canvassize.y-point[3].y-yshift+15);
	      grf.drawString(Integer.toString(size*mag/2),xshift+point[0].x-15,canvassize.y-point[0].y-yshift-size/2);
	      grf.drawString(Integer.toString(size*mag/2),xshift+point[3].x-5,canvassize.y-point[3].y-yshift-size/2);
	    }

	    if(phi < 0){
	      grf.drawLine(xshift+point[1].x,canvassize.y-yshift-point[1].y,xshift+point[1].x,canvassize.y-yshift-point[1].y-size/2);
	      grf.drawLine(xshift+point[2].x,canvassize.y-yshift-point[2].y,xshift+point[2].x,canvassize.y-yshift-point[2].y-size/2);
	      grf.drawLine(xshift+point[3].x,canvassize.y-yshift-point[3].y,xshift+point[3].x,canvassize.y-yshift-point[3].y-size/2);
	      grf.drawLine(xshift+point[3].x,canvassize.y-yshift-point[3].y-size/2,xshift+point[2].x,canvassize.y-yshift-point[2].y-size/2);
		grf.drawLine(xshift+point[3].x,canvassize.y-yshift-point[3].y-size/2,xshift+point[1].x,canvassize.y-yshift-point[1].y-size/2);
		}else{
		grf.drawLine(xshift+point[0].x,canvassize.y-yshift-point[0].y,xshift+point[0].x,canvassize.y-yshift-point[0].y-size/2);
		grf.drawLine(xshift+point[2].x,canvassize.y-yshift-point[2].y,xshift+point[2].x,canvassize.y-yshift-point[2].y-size/2);
		grf.drawLine(xshift+point[3].x,canvassize.y-yshift-point[3].y,xshift+point[3].x,canvassize.y-yshift-point[3].y-size/2);
		grf.drawLine(xshift+point[0].x,canvassize.y-yshift-point[0].y-size/2,xshift+point[2].x,canvassize.y-yshift-point[2].y-size/2);
		grf.drawLine(xshift+point[3].x,canvassize.y-yshift-point[3].y-size/2,xshift+point[2].x,canvassize.y-yshift-point[2].y-size/2);
		}

	    /* Plot 3D */
	    int ic = 0,i,plottype;
	    if((phi < 0 && plotChoice.getSelectedIndex() == 0)
	       || (phi >= 0 && plotChoice.getSelectedIndex() == 1)){
	      plottype = 1;
	    }else{
	      plottype = 0;
	    }
	    if(plottype == 0){
	      i = 0;
	    }else{
	      i = size;
	    }
	    while(ic < size){
	      for(int j=size;j>=0;j--){
		/*for(int j=0;j<size;j++){*/
		int plotcolor;
		int line = StartupDAQ.conFrame.dimdata[dimdatanum].read(i,j);
		if(lineChoice.getSelectedIndex() == 0){
                  line /= mag;
		}else{
                  line = calcLog(line);
		}
		if(line != 0){
		  int rr = line/interval;
		  int yy,yyy,k;
                  for(k=0;k<=rr && k<col.length;k++){
		    plotcolor = colorTable(k);
		    grf.setColor(new Color(plotcolor));
		    if(line > interval*(k+1)){
		      yy = canvassize.y-yshift-ydash(i,j)-(interval*k);
		      yyy = canvassize.y-yshift-ydash(i,j)-(interval*(k+1));
		      if(yyy > 0-interval){
			grf.drawLine(xshift+xdash(i,j),yy,xshift+xdash(i,j),yyy);
		      }
		    }else{
		      yy = canvassize.y-yshift-ydash(i,j)-(interval*k);
		      yyy = canvassize.y-yshift-ydash(i,j)-line;
		      if(yyy > 0-interval){
			grf.drawLine(xshift+xdash(i,j),yy,xshift+xdash(i,j),yyy);
		      }
		    }
                  }
		  if(k == col.length){
		      yy = canvassize.y-yshift-ydash(i,j)-(interval*k);
		      yyy = canvassize.y-yshift-ydash(i,j)-line;
		      if(yyy < 0){
			yyy = 0;
		      }
		      grf.drawLine(xshift+xdash(i,j),yy,xshift+xdash(i,j),yyy);
		  }		    
		}
	      }
	      if(plottype == 0){
		i++;
	      }else{
		i--;
	      }
	      ic++;
	    }
	  }

    /* Threedim ItemListener */
    public void itemStateChanged(ItemEvent evt){
        Object obj = evt.getSource();
        if(obj == dataChoice){
            dimdatanum = dataChoice.getSelectedIndex();
            calcParameters(dimdatanum,thetado,phido);
        }else{
            repaintcanvas();
        }
    }

	  /* ActionListener */
  public void actionPerformed(ActionEvent evt){
    Object obj = evt.getSource();
    if(obj == shortButton){
      mag *= 2;
      updateImage();
      repaintcanvas();
    }else if(obj == tallButton){
      mag /= 2;
      if(mag == 0){
	mag = 1;
      }
      updateImage();
      repaintcanvas();
    }else if(obj == togleButton[0]){
      thetado -= 15;
      if(thetado == 0){
	thetado -= 15;
      }else if(thetado < -75){
	thetado = -75;
      }
      if(thetado < 0 && phido > 0){
	phido = 0- phido;
      }
      calcParameters(dimdatanum,thetado,phido);
    }else if(obj == togleButton[1]){
      thetado += 15;
      if(thetado == 0){
	thetado += 15;
      }else if(thetado > 75){
	thetado = 75;
      }
      if(thetado > 0 && phido < 0){
	phido = Math.abs(phido);
      }
      calcParameters(dimdatanum,thetado,phido);
    }else if(obj == togleButton[2]){
      phido -= 15;
      if(phido == 0){
	phido -= 15;
      }else if(phido < -75){
	phido = -75;
			}
      if(phido < 0 && thetado > 0){
	thetado = 0 - thetado;
      }
      calcParameters(dimdatanum,thetado,phido);
    }else if(obj == togleButton[3]){
      phido += 15;
      if(phido == 0){
	phido += 15;
      }else if(phido > 75){
	phido = 75;
      }
      if(phido > 0 && thetado < 0){
	thetado = Math.abs(thetado);
			}
      calcParameters(dimdatanum,thetado,phido);
    }else if(obj == interButton[0]){
      intervalcnt++;
      setIntervalColor(intervalcnt);
      updateImage();
      repaintcanvas();
    }else if(obj == interButton[1]){
      intervalcnt--;
      setIntervalColor(intervalcnt);
      updateImage();
      repaintcanvas();
    }
  }

    int calcLog(int x){
        int[] log10 = {0,0,0,0,0,0,0,0,0,0,0,
                       2,4,6,7,9,10,12,13,14,15,
                       16,17,18,19,20,21,22,22,23,24,
                       25,25,26,27,27,28,28,29,30,30,
                       31,31,32,32,33,33,34,34,35,35,
                       35,36,36,37,37,37,38,38,39,39,
                       39,40,40,40,41,41,41,42,42,42,
                       43,43,43,43,44,44,44,45,45,45,
                       45,46,46,46,46,47,47,47,47,48,
                       48,48,48,49,49,49,49,50,50,50};
        if(x <= 10){
            return log10[x*10];
        }else if(x <= 100){
            return 50+log10[x];
        }else if(x <= 1000){
            return 100+log10[x/10];
        }else if(x <= 10000){
            return 150+log10[x/100];
        }else if(x <= 100000){
            return 200+log10[x/1000];
        }else if(x <= 1000000){
            return 250+log10[x/10000];
        }else{
            return 500;
        }
    }

	int colorTable(int a){
	/*
      int[] col = {0x000066,0x003366,0x000099,0x003399,0x0000cc,
                   0x0033cc,0x0000ff,0x0033ff,0x0066ff,0x3366ff,
                   0x0099ff,0x3399ff,0x6699ff,
                   0x66cc66,0x66ff00,0x99ff66,0xccff00,0xccff99,
                   0xffff33,0xffcccc,0xffcc66,0xffcc00,0xff9966,
                   0xff9900,0xff6666,0xff6600,0xff3366,0xff3300,
                   0xff0066,0xff0000};
	*/
                 /* 0x00ccff,0x66ccff,
                    0x99ccff,0x00cccc,0x33ffff,0x99ffff,0xccffff */
	/* Blue */

      if(a >= col.length){
          a = col.length-1;
      }
      return col[a];
	}

	void setIntervalColor(int in){
		int[] intcol = {2,5,10,20,50,100,300,500,1000};
		if(in < 0){
			intervalcnt = 0;
		}
		if(in >= intcol.length){
			in = intcol.length-1;
		}
		interval = intcol[intervalcnt];
	}

	/* Threedim WindowLintener */
	public void windowClosed(WindowEvent evt){
	}

	public void windowClosing(WindowEvent evt){
		dispose();
	}

	public void windowOpened(WindowEvent evt){
	}

	public void windowIconified(WindowEvent evt){
	}

	public void windowDeiconified(WindowEvent evt){
	}

	public void windowActivated(WindowEvent evt){
	}

	public void windowDeactivated(WindowEvent evt){
	}
}
